GO.hoursapproval.ApprovalGrid = function(config){

	config = config || {};

	var summary = new Ext.grid.GroupSummary();

	config.title=GO.lang.strWeek;

	config.disableSelection=true;


	this.disapproveDialog = new GO.hoursapproval.DisapproveDialog();

	this.disapproveDialog.on('save', function(){
		this.store.load();
	}, this);


	Ext.grid.GridSummary.Calculations.hours_approval_store_user_id=function(v, record, field, data){
			data['user_id']=record.get('user_id');
			data['status']=record.get('status');
			if(record.data.status!="1")
				data.approve=1;
		};
	
	config.plugins=[summary];

	var appr_style = 'color: #33691e;background-color: #dcedc8;';

	var columns=[{
		header : GO.projects.lang.project,
		dataIndex : 'name',
		width : 220,
		renderer:function(v, meta, record){
			switch(record.get('status')){
				case "2":
					meta.css='go-icon-cross';
				break;

				case "1":
					meta.css='go-icon-ok';
				break;

				default:
					meta.css='go-icon-unknown';
					break;
			}

			return v;
		},
		summaryType:'hours_approval_store_user_id',
		summaryRenderer : function(v, cell, record){
			var s= GO.lang.totals+':<br /><br /><div class="ha-approval-buttons">';

			if(record.data.approve)
				s +='<div id="approve_'+record.data.user_id+'" class="ha-approve"></div>';

			//if(record.data.status=="0" || record.data.status=="1")
			s +='<div id="disapprove_'+record.data.user_id+'" class="ha-disapprove"></div>';

			s += '</div>';

			return s;
		}
	},{
		header : GO.projects.lang.customer,
		dataIndex : 'customer',
		width : 200,
		hidden:true
	}, {
		header : GO.lang.strUser,
		dataIndex : 'user_name',
		width : 200
	},  {
		header : GO.lang.shortDays[1],
		id : 'days_1',
		dataIndex : 'days_1',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_1){ meta.style += appr_style;} return v; }

	}, {
		header : GO.lang.shortDays[2],
		id : 'days_2',
		dataIndex : 'days_2',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_2){ meta.style += appr_style;} return v; }

	}, {
		header : GO.lang.shortDays[3],
		id : 'days_3',
		dataIndex : 'days_3',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_3){ meta.style += appr_style;} return v; }

	},{
		header : GO.lang.shortDays[4],
		id : 'days_4',
		dataIndex : 'days_4',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_4){ meta.style += appr_style;} return v; }

	}, {
		header : GO.lang.shortDays[5],
		dataIndex : 'days_5',
		id : 'days_5',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_5){ meta.style += appr_style;} return v; }

	}, {
		header : GO.lang.shortDays[6],
		dataIndex : 'days_6',
		id : 'days_6',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_6){ meta.style += appr_style;} return v; }
	}, {
		header : GO.lang.shortDays[0],
		dataIndex : 'days_0',
		id : 'days_0',
		align : "right",
		summaryType:'sum',
		width : 70,
		renderer: function(v, meta, rec) { if(rec.data.approved_0){ meta.style += appr_style;} return v; }
	}, {
		header : GO.projects.lang.fee,
		dataIndex : 'fee',
		width : 65,
		align:"right"
	},{
		id:'ha-total',
		header : GO.lang.total,
		dataIndex : 'week_total',
		align : "right",
		summaryType:'sum',
		width : 65
	},{
		id:'ha-total-fees',
		header : GO.lang.total+' '+GO.settings.currency,
		dataIndex : 'week_total_fee',
		align : "right",
		summaryType:'sum',
		width : 65
	}];
	

	var columnModel = new Ext.grid.ColumnModel({
		defaults:{
			sortable:false
		},
		columns:columns
	});

	config.loadMask = true;
	
	config.cm = columnModel;
	config.view = new Ext.grid.GroupingView({
            showGroupName: false,
            enableNoGroups:false, // REQUIRED!
			enableGroupingMenu:false,
            hideGroupedColumn: true,
			emptyText : GO.lang['strNoItems']
        });
				
	//config.sm = new Ext.grid.RowSelectionModel();

	var reader = new Ext.data.JsonReader({
    root: 'results',
    totalProperty: 'total',
		fields : ['project_id', 'fee','user_name', 'user_id','name', 'customer', 'days_0', 'days_1',
					'days_2', 'days_3', 'days_4', 'days_5', 'days_6', 'due_time',
					'approved_0', 'approved_1','approved_2', 'approved_3', 'approved_4', 'approved_5', 'approved_6',
					'week_total','week_total_fee','status']
});

	config.store = new Ext.data.GroupingStore({
			url : GO.settings.modules.hoursapproval.url + 'json.php',
			baseParams : {
				task : 'approval',
				date : ''
			},
			sortInfo:{field: 'name', direction: "ASC"},
			id : 'id',
			reader:reader,
			groupField:'user_name'
		});

	config.store.on('load', function(){
		this.renderButtons();
	}, this);

	GO.hoursapproval.ApprovalGrid.superclass.constructor.call(this, config);

	this.addEvents({
		'approve':true,
		'disapprove':true
	});

	this.on('approve', function(grid, user_id){
		this.sendRequest('approve', this.store.reader.jsonData.hours_ids[user_id]);
	}, this);

	this.on('disapprove', function(grid, user_id){
		this.disapproveDialog.show({hours:this.store.reader.jsonData.hours_ids[user_id], date:this.store.baseParams.date, user_id:user_id});
	}, this);

	if(GO.projects){
		this.on('rowdblclick',function(grid,rowIndex,event){
			var record = grid.store.getAt(rowIndex);
			if (!GO.hoursapproval.hoursGrid) {
				GO.hoursapproval.hoursGrid = new GO.hoursapproval.HoursGrid();
			}
			GO.hoursapproval.hoursGrid.setTbarInfo(record.data['name'],record.data['user_name']);
			GO.hoursapproval.hoursGrid.show(record.data['project_id'],record.data['user_id'],this.weekstartDate);
		}, this);
	}

}

Ext.extend(GO.hoursapproval.ApprovalGrid, GO.grid.GridPanel, {

	weekstartDate : false,

 setDate : function(date){

		if (!date) {
			var now = new Date();
			date = now.getLastSunday();
			date = date.add(Date.DAY,parseInt(GO.settings.first_weekday));
		}
		
		this.weekstartDate = date;

		//var firstWeekDay = date.add(Date.DAY,parseInt(GO.settings.first_weekday));
		this.setTitle(GO.lang.strWeek+' '+date.format('W')+' ('+date.format(GO.settings.date_format)+')');

		this.store.baseParams.date = date.format(GO.settings.date_format);

		this.store.load();

		for (var day = 1; day < 8; day++) {
			var displayDay = date.add(Date.DAY, day-1).format('j');
			var shortDay = (day != 7) ? day : 0;
			var col_index = this.getColumnModel().getIndexById('days_'+shortDay);
			this.getColumnModel().setColumnHeader(
					col_index,
					GO.lang.shortDays[shortDay] + " (" + displayDay
							+ ")");
		}
	},

	sendRequest : function(task, hours, msg){
		
		Ext.Ajax.request({
			url:GO.settings.modules.hoursapproval.url+'action.php',
			params:{
				msg:msg,
				task:task,
				date:this.store.baseParams.date,
				hours:Ext.encode(hours)
			},
			callback:function(){
				this.store.reload();
			},
			scope:this
		});
		
	},

	renderButtons : function(){
		var elements = this.body.query('.ha-approve');
		for(var i=0;i<elements.length;i++){
			new Ext.Button({
				text:GO.hoursapproval.lang.approve,
				renderTo:elements[i],
				handler:function(b){
					var domId = b.container.id;
					var pos = domId.indexOf('_');
					var user_id=parseInt(domId.substring(pos+1));
					this.fireEvent('approve', this, user_id);
				},
				scope:this
			});
		}
		
		var elements = this.body.query('.ha-disapprove');
		for(var i=0;i<elements.length;i++){
			new Ext.Button({
				text:GO.hoursapproval.lang.disapprove,
				renderTo:elements[i],
				handler:function(b){
					var domId = b.container.id;
					var pos = domId.indexOf('_');
					var user_id=parseInt(domId.substring(pos+1));
					this.fireEvent('disapprove', this, user_id);
				},
				scope:this
			});
			
		}
	},
	afterRender : function() {
		GO.hoursapproval.ApprovalGrid.superclass.afterRender.call(this);
		this.setDate();
	},
	renderDay : function(v, p, record, rowIndex, colIndex, ds) {

		if(record.get('totals')){
			return '<br />'+v;
		}else
		{
			return v;
		}
	}
});

