/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: DisapproveDialog.js 20619 2015-06-25 14:17:57Z mdhart $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.hoursapproval.DisapproveDialog = function(config){
	if(!config)
	{
		config={};
	}
	this.buildForm();
	var focusFirstField = function(){
		this.formPanel.items.items[0].focus();
	};
	config.collapsible=true;
	config.cls='go-form-panel';
	config.layout='fit';
	config.modal=false;
	config.resizable=true;
	config.width=500;
	config.height=300;
	config.closeAction='hide';
	config.title= GO.hoursapproval.lang.disapprove;
	config.items= this.formPanel;
	config.focus= focusFirstField.createDelegate(this);
	config.buttons=[{
			text: GO.lang['cmdOk'],
			handler: function(){
				this.submitForm(true);
			},
			scope: this
		},{
			text: GO.lang['cmdCancel'],
			handler: function(){
				this.hide();
			},
			scope:this
		}
	];
	GO.hoursapproval.DisapproveDialog.superclass.constructor.call(this, config);
	this.addEvents({'save' : true});
}
Ext.extend(GO.hoursapproval.DisapproveDialog, Ext.Window,{
	show : function (config) {
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}

		this.formPanel.baseParams.hours=Ext.encode(config.hours);
		this.formPanel.baseParams.date=config.date;
		this.formPanel.baseParams.user_id=config.user_id;

		this.formPanel.form.reset();
		
		GO.hoursapproval.DisapproveDialog.superclass.show.call(this);
	},
	submitForm : function(hide){
		this.formPanel.form.submit(
		{
			url:GO.settings.modules.hoursapproval.url+'action.php',
			params: {'task' : 'disapprove'},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action){
				if(action.result.sucess == 'false') {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
				this.fireEvent('save', this);
				this.hide();
			},
			failure: function(form, action) {
				if(action.failureType == 'client')
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});
	},
	buildForm : function () {
    this.formPanel = new Ext.form.FormPanel({
	    waitMsgTarget:true,
			url: GO.settings.modules.hoursapproval.url+'action.php',
			border: false,
			labelAlign:'top',
			baseParams: {task: 'report_template'},
			items:[{
				xtype: 'textarea',
			  name: 'msg',
				anchor: '100% -30',
			  fieldLabel: GO.hoursapproval.lang.enterDisapproveReason,
				allowBlank: false
			}]
		});
	}
});
