GO.hoursapproval.HoursGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	this.buildGrid();
	
	config.width = 740;
	config.height = 500;
	config.layout = 'fit';
	
	config.items = [this.gridPanel];
	
	GO.hoursapproval.HoursGrid.superclass.constructor.call(this, config);

};


Ext.extend(GO.hoursapproval.HoursGrid, GO.Window, {
		
	show: function(project_id,user_id,startDate){		
				
		var endDate = new Date(startDate.getFullYear(),startDate.getMonth(),startDate.getDate()+6);
				
		this.gridPanel.store.baseParams['project_id'] = project_id;
		this.gridPanel.store.baseParams['user_id'] = user_id;
		this.gridPanel.store.baseParams['start_date'] = startDate.format(GO.settings.date_format);
		this.gridPanel.store.baseParams['end_date'] = endDate.format(GO.settings.date_format);
		this.gridPanel.store.load();
		
		GO.hoursapproval.HoursGrid.superclass.show.call(this);
		
	},
					
	setTbarInfo: function(projectName,userName) {
		
//		this.projectNameField.setValue(projectName);
//		this.userNameField.setValue(userName);
		
		this.setTitle(projectName+' - '+userName);
		
	},
					
	buildGrid : function() {

		var columns = [
			{
				header:GO.projects.lang.units,
				dataIndex: 'units',
				width:50,
				align:'right'
			},
			{
				header:GO.projects.lang.project,
				dataIndex: 'project_name',
				width:120
			},
			{
				header:GO.lang.strUser,
				dataIndex: 'user_name',
				width:120,
				sortable:false
			},
			{
				header:GO.lang.strDate,
				dataIndex: 'date',
				width:80
			},
			{
				header:GO.projects.lang.fee,
				dataIndex: 'fee_name',
				width:120
			},
			{
				header:GO.lang.strCtime,
				dataIndex: 'ctime',
				hidden:true,
				width:110
			},
			{
				header:GO.lang.strMtime,
				dataIndex: 'mtime',
				hidden:true,
				width:110
			}
			];

		if(GO.settings.modules.projects.write_permission)
		{
			columns.splice(columns.length,0,{
				header:GO.projects.lang.internalFee,
				dataIndex: 'int_fee_value',
				sortable:false,
				align:'right'
			},{
				header:GO.projects.lang.externalFee,
				dataIndex: 'ext_fee_value',
				sortable:false,
				align:'right'
			},{
				header:GO.projects.lang.profit,
				dataIndex: 'profit',
				sortable:false,
				align:'right',
				sortable:false
			},{
				header:GO.projects.lang.invoiceId,
				dataIndex: 'invoice_id',
				sortable:true
			},{
				header:GO.projects.lang.payoutInvoiceId,
				dataIndex: 'payout_invoice_id',
				sortable:true
			});
		}

		columns.push({
			header:GO.hoursapproval.lang.approved,
			dataIndex: 'status',
			sortable:true,
			width:30
		});
		
		this.gridPanel = new GO.grid.GridPanel({
			store : new GO.data.JsonStore({
				url: GO.settings.modules.projects.url+'json.php',
				baseParams: {
					'task': 'hours'
					},
				root: 'results',
				totalProperty: 'total',
				id: 'id',
				fields:['id','units', 'user_name', 'date', 'fee_name', 'comments', 'project_name', 'int_fee_value', 'ext_fee_value', 'profit','invoice_id','payout_invoice_id','ctime','mtime','status'],
				remoteSort:true
			}),
			stateId : 'pm-hours-table',
			paging : true,
//			tbar : [
//				this.projectNameField = new GO.form.PlainField({
//					value: ''
//				}),
//				'-',
//				this.userNameField = new GO.form.PlainField({
//					value: ''
//				})
//			],
			view : new Ext.grid.GridView({
				emptyText: GO.projects.lang.noHours,
				enableRowBody:true,
				showPreview:true,
				getRowClass : function(record, rowIndex, p, store){
						if(this.showPreview){
								p.body = '<p class="pm-hours-comments">'+record.data.comments+'</p>';
								return 'x-grid3-row-expanded';
						}
						return 'x-grid3-row-collapsed';
				}
			}),
			sm : new Ext.grid.RowSelectionModel(),
			loadMask : true,
			cm : new Ext.grid.ColumnModel({
				defaults:{
					sortable:true
				},
				columns:columns
			})
		});
		
	}
	
});
