
GO.hoursapproval.MainPanel = function(config){

	if(!config)
	{
		config = {};
	}

	config.layout='border';
	config.border=false;

	this.navPanel = new GO.projects.NavigationPanel({
		title:GO.lang.strWeek,
		url:GO.settings.modules.hoursapproval.url + 'json.php',
		region:'west',
		split:true,
		width:100
	});

	this.navPanel.getSelectionModel().on('rowselect', function(sm, i, record){
		return this.approvalGrid.setDate(Date.parseDate(record.get('value'), GO.settings.date_format));
	}, this);


	this.approvalGrid = new GO.hoursapproval.ApprovalGrid({
		region:'center',
		id:'ha-approvalgrid'
	});

	this.approvalGrid.store.on('load', function(){

		var closed = this.approvalGrid.store.findBy(function(r){
			return r.get('status')!=1;
		}, this) >-1 ? 0 : 1;

		var i = this.navPanel.store.findBy(function(r){
			return r.get('value')==this.approvalGrid.store.baseParams.date;
		}, this);

		if(i>-1){
			var r = this.navPanel.store.getAt(i);
			r.set('closed', closed);
		}

	}, this);

	config.items=[this.approvalGrid,this.navPanel];

	var tbarItems=[{
	    xtype:'htmlcomponent',
			html:GO.hoursapproval.lang.name,
			cls:'go-module-title-tbar'
		},
//		{
//			iconCls: 'btn-print',
//			text: GO.lang.cmdPrint,
//			cls: 'x-btn-text-icon',
//			handler: function(){
//				//console.log(BaseHref+'modules/timeregistration/print_report.php?date='+this.navPanel.getSelectionModel().selections.items[0].data.value+'&user_id='+this.navPanel.store.baseParams.user_id+'&approval=1');
//				window.open(BaseHref+'modules/timeregistration/print_report.php?date='+this.navPanel.getSelectionModel().selections.items[0].data.value+'&user_id='+this.navPanel.store.baseParams.user_id+'&approval=1');
//			},
//			scope: this
//		},
		{
			iconCls: 'btn-refresh',
			text: GO.lang.cmdRefresh,
			cls: 'x-btn-text-icon',
			handler: function(){
				this.navPanel.store.reload();
				this.approvalGrid.store.reload();
			},
			scope: this
		}];

	if(GO.settings.modules.timeregistration.write_permission){
		tbarItems.push('-',GO.lang.strUser+':',
			this.selectUser = new GO.form.SelectUser({
				width:200,
				listeners:{
					select:function(cb, r){
						this.approvalGrid.store.baseParams.user_id=r.id;
						this.navPanel.store.baseParams.user_id=r.id;
						this.navPanel.store.load();
					},
					scope:this
				}
			})
		);
	}

	config.tbar= new Ext.Toolbar({
		cls:'go-head-tb',
		items:tbarItems
	});

	GO.hoursapproval.MainPanel.superclass.constructor.call(this, config);
};


Ext.extend(GO.hoursapproval.MainPanel, Ext.Panel, {

	onShow : function(){

		GO.hoursapproval.MainPanel.superclass.onShow.call(this);
	},
	afterRender : function(){

		this.navPanel.store.load({
			callback:function(){
				this.navPanel.getSelectionModel().selectFirstRow();
			},
			scope:this
		});

		GO.hoursapproval.MainPanel.superclass.afterRender.call(this);
	}

});


GO.moduleManager.addModule('hoursapproval', GO.hoursapproval.MainPanel, {
	title : GO.hoursapproval.lang.hoursapproval,
	iconCls : 'go-tab-icon-hoursapproval'
});