GO.hoursapproval.SetWeekDialog = function(config) {
	var config = config || {};
	this.buildForm();
	config.title = GO.projects.lang['openCloseWeek'];
	config.border=false;
	config.collapsible=true;
	config.layout='fit';
//		config.layoutConfig={
//			deferredRender:false,
//			layoutOnCardChange:true
//		};
	config.modal=false;
	config.resizable=true;
	config.width=300;
	config.height=250;
	config.closeAction='hide';
	config.cls='go-form-panel';
	config.items = [this.formPanel];
	config.buttons=[{
		text: GO.projects.lang['openWeek'],
		handler: function(){
			this.submitForm('open');
		},
		scope: this
	},{
		text: GO.projects.lang['closeWeek'],
		handler: function(){
			this.submitForm('close');
		},
		scope: this
	},{
		text: GO.lang['cmdCancel'],
		handler: function(){
			this.hide();
		},
		scope:this
	}];
	GO.hoursapproval.SetWeekDialog.superclass.constructor.call(this,config);
}

Ext.extend(GO.hoursapproval.SetWeekDialog,GO.Window,{
	
	buildForm : function() {
		this.formPanel = new Ext.form.FormPanel({
			url: GO.url('projects/week/setWeeks'),
			layout : 'form',
			items : [new GO.form.PlainField({
				hideLabel : true,
				value : GO.hoursapproval.lang['openCloseWeekInstructions']
			}), this.dateField = new Ext.form.DateField({
				name : 'date',
				width : 100,
				format : GO.settings['date_format'],
				allowBlank : false
			}), this.yearField = new GO.form.PlainField({
				name : 'year',
				fieldLabel : GO.projects.lang['year']
			}), this.weekField = new GO.form.PlainField({
				name : 'week',
				fieldLabel : GO.projects.lang['week']
			})]
		});
		
		this.dateField.on('select',function(dateField,dateValue){
			this.onDatePicked();
		},this);

	},
	
	onDatePicked : function() {
		var fullYear = this.dateField.getValue().getFullYear();
		var monthNr = this.dateField.getValue().getMonth()+1;
		var weekNr = this.dateField.getValue().getWeekOfYear();
		
		if (weekNr==1 && monthNr==12)
			fullYear+=1;
		
		this.yearField.setValue(fullYear);
		this.weekField.setValue(weekNr);
	},
	
	show : function(config) {
		GO.hoursapproval.SetWeekDialog.superclass.show.call(this,config);
		var now = new Date();
		this.dateField.setValue(now.format(GO.settings.date_format));
		this.onDatePicked();
	},
	
	submitForm : function(openCloseString) {
		if (openCloseString=='open') {
			var askString = GO.hoursapproval.lang['openWeeksAsk'].replace('%wnr',this.weekField.getValue());
			var titleString = GO.projects.lang['openWeek'];
		} else if (openCloseString=='close') {
			var askString = GO.hoursapproval.lang['closeWeeksAsk'].replace('%wnr',this.weekField.getValue());
			var titleString = GO.projects.lang['closeWeek'];
		}
		
		if (openCloseString == 'open' || openCloseString == 'close') {
			Ext.Msg.show({
				title: titleString,
				msg: askString,
				buttons: Ext.Msg.YESNO,
				scope: this,
				icon: Ext.MessageBox.WARNING,
				fn: function(btn) {
					if (btn=='yes') {
						this.formPanel.form.submit({
							url: GO.url('projects/week/setWeeks'),
							params: {'openCloseString' : openCloseString},
							waitMsg:GO.lang['waitMsgSave'],
							success:function(form, action){
								if (openCloseString=='open')
									Ext.MessageBox.alert(GO.lang['strSuccess'],GO.hoursapproval.lang['openWeekSuccess'].replace('%ws',action.result.weekStart).replace('%we',action.result.weekEnd).replace('%wnr',action.result.weekNr));
								else if (openCloseString=='close')
									Ext.MessageBox.alert(GO.lang['strSuccess'],GO.hoursapproval.lang['closeWeekSuccess'].replace('%ws',action.result.weekStart).replace('%we',action.result.weekEnd).replace('%wnr',action.result.weekNr));
							},		
							failure: function(form, action) {
								if (action.failureType == 'client') {
									Ext.MessageBox.alert(GO.lang['strError'],
											GO.lang['strErrorsInForm']);
								} else {
									Ext.MessageBox.alert(GO.lang['strError'],
											action.result.feedback);
								}
							},
							scope: this
						});
					}
				}
			});
		} else {
			Ext.MessageBox.alert(GO.lang['strError'],'Please inform the administrator about the following: GO.hoursapproval.SetWeekDialog.submitForm() called without valid arguments.');
		}
	}
});

GO.hoursapproval.showSetWeekDialog = function() {
	if (!GO.hoursapproval.setWeekDialog) {
		GO.hoursapproval.setWeekDialog = new GO.hoursapproval.SetWeekDialog();
	}
	GO.hoursapproval.setWeekDialog.show();
}