/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: CustomReportsGrid.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.CustomReportsGrid = function(config){
	if(!config)
	{
		config = {};
	}
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	var fields ={
		fields:['id','project_id','template_name','start_time','end_time'],
		columns:[{
			header: GO.projects.lang.reportTemplate,
			dataIndex: 'template_name'
		},{
			header: GO.projects.lang.startTime, 
			dataIndex: 'start_time'
		},{
			header: GO.projects.lang.endTime, 
			dataIndex: 'end_time'
		}]
	};
		if(GO.customfields)
	{
		GO.customfields.addColumns(14, fields);
	}
	config.store = new GO.data.JsonStore({
	    url: GO.url('projects/customReport/store'),
	    baseParams: {
//	    	task: 'custom_reports'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: fields.fields,
	    remoteSort: true
	});
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:fields.columns
	});
	
	config.cm=columnModel;
	//config.disabled=true;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	this.customReportDialog = new GO.projects.CustomReportDialog();
	this.customReportDialog.on('save', function(){
			this.store.reload();	    			    			
		}, this);

	config.tbar=[{
			iconCls: 'btn-add',							
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
	    	this.customReportDialog.show(0);
			},
			scope: this
		},{
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		}];


	GO.projects.CustomReportsGrid.superclass.constructor.call(this, config);
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);	
		this.customReportDialog.show(record.data.id);
		}, this);
};
Ext.extend(GO.projects.CustomReportsGrid, GO.grid.GridPanel,{
	setProjectId : function(project_id, files_folder_id){
		this.store.baseParams.project_id=project_id;
		this.customReportDialog.formPanel.baseParams.project_id=project_id;
		this.customReportDialog.files_folder_id=files_folder_id;
		this.store.load();
	}
});
