/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ExpenseTypes.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */

/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ExpenseTypes.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.projects.expenseTypesStore= new GO.data.JsonStore({
		url: GO.url('projects/expenseType/store'),
		baseParams: {
//			task: 'expense_types'
		},
		root: 'results',
		id: 'id',
		totalProperty:'total',
		fields: ['id','name'],
		remoteSort: true
	});

/*GO.projects.SelectExpenseType = Ext.extend(GO.form.ComboBox, {
			initComponent : function(){
				Ext.apply(this, {
					fieldLabel: GO.projects.lang.type,
					store:GO.projects.expenseTypesStore,
					valueField:'name',
					displayField:'name',
					mode: 'local',
					triggerAction: 'all',
					editable: true,
					selectOnFocus:true,
					allowBlank:false,
					forceSeleciton:false
				});

				Ext.form.TwinTriggerField.prototype.initComponent.call(this);
			},
			getTrigger : Ext.form.TwinTriggerField.prototype.getTrigger,
			initTrigger : Ext.form.TwinTriggerField.prototype.initTrigger,
			trigger1Class : 'x-form-edit-trigger',
			hideTrigger1 : !GO.settings.modules.projects.write_permission,
			onTrigger2Click : function() {
				this.onTriggerClick();
			},
			onTrigger1Click : function() {

				var v = this.getValue();

				if(!GO.projects.expenseTypeDialog){
					GO.projects.expenseTypeDialog = new Ext.Window({
						title:GO.projects.lang.expenseTypes,
						initComponent : function(){
							this.expenseTypesGrid = new GO.projects.ExpenseTypes();
							this.items=[this.expenseTypesGrid];

							this.constructor.prototype.initComponent.call(this);

						},
						layout:'fit',
						width:300,
						height:300,
						closeAction:'hide',
						buttons:[{
								text:GO.lang.cmdOk,
								handler:function(){
									GO.projects.expenseTypeDialog.getEl().mask(GO.lang.waitMsgLoad);
									
									Ext.Ajax.request({
										url:GO.settings.modules.projects.url+'action.php',
										params:{
											task:'save_expense_types',
											expense_types:Ext.encode(GO.projects.expenseTypeDialog.expenseTypesGrid.getGridData())
										},
										callback:function(options, success, response){

											var result = Ext.decode(response.responseText);

											if(result.new_incomes)
											{
												GO.projects.expenseTypeDialog.expenseTypesGrid.setIds(result.new_incomes);
											}
											GO.projects.expenseTypeDialog.expenseTypesGrid.store.commitChanges();
											GO.projects.expenseTypeDialog.getEl().unmask();
											GO.projects.expenseTypeDialog.hide();
										}
								});
							}
						}]
					});
				}

				GO.projects.expenseTypeDialog.show();

			},
			setValue : function(v){
				GO.form.ComboBoxReset.superclass.setValue.call(this, v);
				if(this.rendered)
				{
					//this.triggers[0].setDisplayed(v!='');
				}
			},
			afterRender:function(){
				GO.form.ComboBoxReset.superclass.afterRender.call(this);
				if(Ext.isIE8)this.el.setTop(1);

				if(!GO.projects.expenseTypesStore.loaded)
					GO.projects.expenseTypesStore.load();

				//this.on('resize', function(combo, adjWidth, adjHeight, rawWidth, rawHeight ){console.log(adjWidth);}, this);
			}
		});
*/

GO.projects.SelectExpenseType = Ext.extend(GO.form.ComboBox, {
			initComponent : function(){
				Ext.apply(this, {
					fieldLabel: GO.projects.lang.type,
					store:GO.projects.expenseTypesStore,
					valueField:'name',
					displayField:'name',
					mode: 'local',
					triggerAction: 'all',
					editable: true,
					allowBlank:false,
					forceSeleciton:false
				});

				GO.form.ComboBox.superclass.initComponent.call(this);
			},

			afterRender:function(){
				GO.form.ComboBoxReset.superclass.afterRender.call(this);

				if(!GO.projects.expenseTypesStore.loaded)
					GO.projects.expenseTypesStore.load();
			}
		});



GO.projects.ExpenseTypes = function(config){
	if(!config)
	{
		config = {};
	}

	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.title=GO.projects.lang.expenseTypes;

	config.store =GO.projects.expenseTypesStore;

	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[	{
			header: GO.lang.strName,
			dataIndex: 'name',
			editor: new Ext.form.TextField({
				allowBlank: false
			})
		}]
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	config.clicksToEdit=1;


	var ExpenseType = Ext.data.Record.create([
	// the "name" below matches the tag name to read, except "availDate"
	// which is mapped to the tag "availability"
	{
		name: 'id',
		type: 'int'
	},

	{
		name: 'name',
		type: 'string'
	}]);


	config.tbar=[{
		iconCls: 'btn-add',
		text: GO.lang['cmdAdd'],
		cls: 'x-btn-text-icon',
		handler: function(){
			var e = new ExpenseType({
				id: '0',
				name:''
			});
			this.stopEditing();
			this.store.insert(0, e);
			this.startEditing(0, 0);
		},
		scope: this
	},{
		iconCls: 'btn-delete',
		text: GO.lang['cmdDelete'],
		cls: 'x-btn-text-icon',
		handler: function(){
			var selectedRows = this.selModel.getSelections();
			for(var i=0;i<selectedRows.length;i++)
			{
				selectedRows[i].commit();
				this.store.remove(selectedRows[i]);
			}
		},
		scope: this
	}
	/*
	,'-',{
		iconCls:'btn-save',
		text:GO.lang.cmdSave,
		handler:function(){
			this.getEl().mask(GO.lang.waitMsgLoad);

			Ext.Ajax.request({
				url:GO.settings.modules.projects.url+'action.php',
				params:{
					task:'save_expense_types',
					expense_types:Ext.encode(this.getGridData())
				},
				callback:function(options, success, response){

					var result = Ext.decode(response.responseText);

					if(result.new_incomes)
					{
						this.setIds(result.new_incomes);
					}
					this.store.commitChanges();
					this.getEl().unmask();

				},
				scope:this
			});
		},
		scope:this
	}
	*/

];
	GO.projects.ExpenseTypes.superclass.constructor.call(this, config);

};
Ext.extend(GO.projects.ExpenseTypes, Ext.grid.EditorGridPanel,{

	afterRender : function(){

		if(!GO.projects.expenseTypesStore.loaded)
				GO.projects.expenseTypesStore.load();

		GO.projects.ExpenseTypes.superclass.afterRender.call(this);
	},
	onShow : function(){
		if(!this.store.loaded){
			this.store.load();
		}
		GO.projects.ExpenseTypes.superclass.onShow.call(this);
	},
	getGridData : function(){

		var data = {};

		for (var i = 0; i < this.store.data.items.length;  i++)
		{
			var r = this.store.data.items[i].data;

			data[i]={};

			for(var key in r)
			{
				data[i][key]=r[key];
			}
		}

		return data;
	},
	setIds : function(ids)
	{
		for(var index in ids)
		{
			if(index!="remove")
			{
				this.store.getAt(index).set('id', ids[index]);
			}
		}
	}
});
