/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ExpensesWindow.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.ExpensesWindow = function(config){
	if(!config)
	{
		config={};
	}

	this.expensesPanel = new GO.projects.ExpensesGrid();
	
	config.title = GO.projects.lang.expenses;
	config.collapsible=true;
	config.maximizable=true;
	config.layout='fit';
	config.modal=false;
	config.resizable=true;
	config.width=750;
	config.height=500;
	config.closeAction='hide';
	config.items= [this.expensesPanel];

	config.buttons=[{
		text: GO.lang['cmdOk'],
		handler: function(){
			//this.hide();

			this.el.mask(GO.lang.waitMsgLoad);
			Ext.Ajax.request({
				url: GO.settings.modules.projects.url+'action.php',
				params:{
					task:'save_expenses',
					project_id: this.expensesPanel.project_id,
					expenses: Ext.encode(this.expensesPanel.getGridData())
				},
				callback: function(options, success, response)
					{
						this.el.unmask();
						if(!success)
						{
							alert( GO.lang['strRequestError']);
						}else
						{
							var responseParams = Ext.decode(response.responseText);
							if(!responseParams.success)
							{
								alert( responseParams.feedback);
							}else
							{
								this.hide();
							}
						}
					},
					scope:this
			});


		},
		scope:this
	}
	];
	GO.projects.ExpensesWindow.superclass.constructor.call(this, config);
}
Ext.extend(GO.projects.ExpensesWindow, Ext.Window,{
	show : function (project_id) {
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}


		this.expensesPanel.setProjectId(project_id);
		this.expensesPanel.store.load();


		GO.projects.ExpensesWindow.superclass.show.call(this);
	}
});
