GO.projects.GoToWeekDialog = function(config) {

	if (!config) {
		config = {};
	}

	this.buildForm();

	var focusFirstField = function() {
		this.formPanel.items.items[0].focus();
	};

	config.layout = 'fit';
	config.title = GO.projects.lang.goToWeek;
	config.modal = false;
	config.width = 335;
	config.height = 135;
	config.resizable = false;
	config.closeAction = 'hide';
	config.items = this.formPanel;
	config.focus = focusFirstField.createDelegate(this);
	config.buttons = [{
				text : GO.lang['cmdClose'],
				handler : function() {
					this.hide();
				},
				scope : this
			}];

	GO.projects.GoToWeekDialog.superclass.constructor.call(this, config);

}
Ext.extend(GO.projects.GoToWeekDialog, Ext.Window, {

	show : function(grid) {
		this.grid = grid;

		if (!this.rendered) {
			this.render(Ext.getBody());
		}

		var pos = this.grid.periodInfoPanel.getPosition();
		this.setPosition(pos[0], pos[1] + 20);

		this.formPanel.form.reset();

		var now = new Date(this.grid.sunday);
		var thisyear = now.format('Y');
		this.year.setValue(thisyear);

		this.setYear(thisyear);

		GO.projects.GoToWeekDialog.superclass.show.call(this);
	},
	buildForm : function() {
		this.formPanel = new Ext.form.FormPanel({
			cls : 'go-form-panel',
			layout : 'form',
			waitMsgTarget : true,
			labelWidth : 50,
			border : false,
			anchor : '95% 95%',
			items : [this.year = new Ext.form.TextField({
								name : 'year',
								fieldLabel : GO.lang['strYear'],
								allowBlank : false,
								anchor : '95%',
								selectOnFocus : true
							}), this.selectWeek = new GO.form.ComboBox({
						fieldLabel : GO.lang['strWeek'],
						hiddenName : 'date',
						emptyText : GO.projects.lang.selectWeek,
						store : new GO.data.JsonStore({
							url : GO.settings.modules.projects.url + 'json.php',
							baseParams : {
								task : 'get_weeks'
							},
							root : 'results',
							id : 'value',
							totalProperty : 'total',
							fields : ['value', 'text'],
							remoteSort : true
						}),
						valueField : 'value',
						displayField : 'text',
						mode : 'local',
						triggerAction : 'all',
						editable : true,
						selectOnFocus : true,
						forceSelection : true,
						allowBlank : false,
						anchor : '95%'
					})]
		});

		this.year.on('change', function() {
					this.setYear(this.year.getValue());
				}, this);

		this.selectWeek.on('select', function(combo, record) {
					var newDate = new Date(this.selectWeek.getValue() * 1000);
					dateString = newDate.toUTCString();

					this.grid.setDate(new Date(dateString));

					this.hide();

				}, this);

	},
	setYear : function(year) {
		this.selectWeek.store.baseParams.year = year;
		this.selectWeek.store.load();
	}
});