GO.projects.HoursGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	
	
	config.store = new GO.data.JsonStore({
		url: GO.settings.modules.projects.url+'json.php',
		baseParams: {
			'task': 'hours'
			},
		root: 'results',
		totalProperty: 'total',
		id: 'id',
		fields:['id','units', 'user_name', 'date', 'fee_name', 'comments', 'project_name', 'int_fee_value', 'ext_fee_value', 'profit','invoice_id','payout_invoice_id','ctime','mtime','status'],
		remoteSort:true
	});

	if(config.project_id)
	{
		this.setProjectId(config.project_id);
	}
	
		
	//config.cls='pm-hours-table',
	config.stateId='pm-hours-table';
	config.paging=true;

	var columns = [
		{
			header:GO.projects.lang.units,
			dataIndex: 'units',
			width:50,
			align:'right'
		},
		{
			header:GO.projects.lang.project,
			dataIndex: 'project_name',
			width:120
		},
		{
			header:GO.lang.strUser,
			dataIndex: 'user_name',
			width:120,
			sortable:false
		},
		{
			header:GO.lang.strDate,
			dataIndex: 'date',
			width:80
		},
		{
			header:GO.projects.lang.fee,
			dataIndex: 'fee_name',
			width:120
		},
		{
			header:GO.lang.strCtime,
			dataIndex: 'ctime',
			hidden:true,
			width:110
		},
		{
			header:GO.lang.strMtime,
			dataIndex: 'mtime',
			hidden:true,
			width:110
		}
		];

	

	
		
	if(GO.settings.modules.projects.write_permission)
	{
		columns.splice(columns.length,0,{
			header:GO.projects.lang.internalFee,
			dataIndex: 'int_fee_value',
			sortable:false,
			align:'right'
		},{
			header:GO.projects.lang.externalFee,
			dataIndex: 'ext_fee_value',
			sortable:false,
			align:'right'
		},{
			header:GO.projects.lang.profit,
			dataIndex: 'profit',
			sortable:false,
			align:'right',
			sortable:false
		},{
			header:GO.projects.lang.invoiceId,
			dataIndex: 'invoice_id',
			sortable:true
		},{
			header:GO.projects.lang.payoutInvoiceId,
			dataIndex: 'payout_invoice_id',
			sortable:true
		});
	}

	if(GO.hoursapproval){
		columns.push({
			header:GO.hoursapproval.lang.approved,
			dataIndex: 'status',
			sortable:true,
			width:30
		});
	}

	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:columns
	});

	config.cm=columnModel;
	
	config.view=new Ext.grid.GridView({
		emptyText: GO.projects.lang.noHours,
		enableRowBody:true,
		showPreview:true,
		getRowClass : function(record, rowIndex, p, store){
		    if(this.showPreview){
		        p.body = '<p class="pm-hours-comments">'+record.data.comments+'</p>';
		        return 'x-grid3-row-expanded';
		    }
		    return 'x-grid3-row-collapsed';
		}
	}),
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	
	config.tbar=[{
			iconCls: 'btn-delete',							
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		}/*,{
			iconCls: 'btn-print',							
			text: GO.lang['cmdPrint'],
			cls: 'x-btn-text-icon',
			handler: function(){				
				var url = GO.settings.modules.projects.url+'print.php?';
				
				for(var i in this.store.baseParams)
				{
					url += i+'='+this.store.baseParams[i]+'&';
				}
				var url = url.substring(0, url.length-1);				
				var win = window.open(url)
				win.focus();
			},
			scope: this
		}*/,{
			iconCls: 'btn-export',
			text: GO.lang.cmdExport,
			scope: this,
			handler: function(){
				if(!this.exportDialog)
				{
					this.exportDialog = new GO.ExportQueryDialog({
						query:'timeregistration'
					});
				}
				this.exportDialog.show({
					colModel:this.getColumnModel(),
					title:this.ownerCt.title
					//searchQuery: this.centerPanel.searchField.getValue()
				});
			}
		}];
	
	GO.projects.HoursGrid.superclass.constructor.call(this, config);

};


Ext.extend(GO.projects.HoursGrid, GO.grid.GridPanel, {
	
	project_id : 0,
	loaded_project_id : 0,
	
	afterRender : function()
	{
		GO.projects.HoursGrid.superclass.afterRender.call(this);		
		
    this.on("rowdblclick", function(grid, rowClicked, e){
				if(!this.hoursDialog)
	    	{    		
	    		this.hoursDialog = new GO.projects.HoursDialog();
	    		this.hoursDialog.on('save', function(){
	    			this.store.reload();    			
	    		}, this);
	    	}   	
	    	this.hoursDialog.show(grid.selModel.selections.keys[0]);    	
			}, this);
	},	
	onShow : function(){		
		GO.projects.HoursGrid.superclass.onShow.call(this);
		
		if(this.loaded_project_id!=this.project_id)
		{
			this.loaded_project_id=this.project_id;
			this.store.load();
		}		
	},
	
	setProjectId : function(project_id)
	{
		this.project_id=project_id;
		this.store.baseParams.project_id=project_id;
	} 
});
