GO.projects.ImportDialog = Ext.extend(Ext.Window, {
	
	initComponent : function(){
		
		this.title=GO.projects.lang.importEvents;
		
		this.width=500;
		this.autoHeight=true;
		
		this.closeAction='hide';
		

		var now = new Date();
	  var lastMonth = now.add(Date.MONTH, -1);
	  var startOfLastMonth = lastMonth.getFirstDateOfMonth();
	  var endOfLastMonth = lastMonth.getLastDateOfMonth();
	  
	  this.startDate = new Ext.form.DateField({    	
				name: 'start_date',
				format: GO.settings['date_format'],
				allowBlank:true,
				fieldLabel: GO.lang.strStart,
				value: startOfLastMonth.format(GO.settings.date_format)
				});
				
		this.endDate = new Ext.form.DateField({    	
				name: 'end_date',
				format: GO.settings['date_format'],
				allowBlank:true,
				fieldLabel: GO.lang.strEnd,
				value: endOfLastMonth.format(GO.settings.date_format)
				});
		
		this.selectProject = new GO.projects.SelectProject({
	  	anchor:'100%'
	  });
	  this.selectFee = new GO.projects.SelectFee({
	  	anchor:'100%'
	  });
	  
	  this.selectCalendar = new GO.form.ComboBox({
	       	fieldLabel: GO.calendar.lang.calendar,
	        hiddenName:'calendar_id',
	        anchor:'100%',
	        emptyText:GO.lang.strPleaseSelect,
	        store: new GO.data.JsonStore({
					    url: GO.settings.modules.calendar.url+ 'json.php',
					    baseParams: {						    	
					    	task: 'calendars'
				    	},
			    root: 'results',
			    id: 'id',
			    totalProperty:'total',
			    fields: ['id', 'name'],
			    remoteSort: true
				}),
				pageSize: parseInt(GO.settings.max_rows_list),
        valueField:'id',
        displayField:'name',
        typeAhead: true,
        mode: 'remote',
        triggerAction: 'all',
        editable: false,
        selectOnFocus:true,
        forceSelection: true,
        allowBlank: false
    	});
		
		this.items=this.formPanel = new Ext.form.FormPanel({
			url:GO.settings.modules.projects.url+'action.php',
			baseParams:{task:'import'},
			bodyStyle:'padding:5px',
			waitMsgTarget:true,
			items:[
			{
				layout:'table', 
				border:false,
				defaults:{border:false, layout:'form'},
				items:[
					{
						items:this.startDate
					},{
						bodyStyle:'padding-left:5px',
						items:new Ext.Button({
							text: GO.projects.lang.previousMonth,
							handler: function(){
								this.changeMonth(-1);
							},
							scope:this
						})
					}]
			}, {
				layout:'table', 
				border:false,
				defaults:{border:false, layout:'form'},
				items:[
					{
						items:this.endDate
					},{
						bodyStyle:'padding-left:5px',
						items:new Ext.Button({
							text: GO.projects.lang.nextMonth,
							handler: function(){
								this.changeMonth(1);
							},
							scope:this
						})
					}]
			}, 
			this.selectProject, 
			this.selectFee, 
			this.selectCalendar]			
		});
		
		this.buttons=[
		{
			text:GO.lang.cmdOk,
			handler: this.submitForm, 
			scope: this
		},
		{
			text:GO.lang['cmdClose'],
			handler: function(){this.hide()}, 
			scope: this
		}];
		
		this.addEvents({'import': true});
		
		GO.users.ImportDialog.superclass.initComponent.call(this);
	},
	submitForm : function(){
		this.formPanel.form.submit({
			waitMsg:GO.lang.waitMsgUpload,			
			success:function(form, action){				
				this.hide();
				
				this.fireEvent('import');

				Ext.MessageBox.alert(GO.lang.strSuccess, action.result.feedback);
			},
			failure: function(form, action) {	
				if(action.failureType == 'client')
				{					
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);			
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});			
	},
	changeMonth : function(increment)
	{
		var date = this.startDate.getValue();
		date = date.add(Date.MONTH, increment);
		this.startDate.setValue(date.getFirstDateOfMonth().format(GO.settings.date_format));
		this.endDate.setValue(date.getLastDateOfMonth().format(GO.settings.date_format));
	}
});

