
GO.projects.incomeTypesStore= new GO.data.JsonStore({
		url: GO.url('projects/incomeType/store'),
		baseParams: {
//			task: 'income_types'
		},
		root: 'results',
		id: 'id',
		totalProperty:'total',
		fields: ['id','name'],
		remoteSort: true
	});


GO.projects.SelectIncomeType = Ext.extend(GO.form.ComboBox, {
			initComponent : function(){
				Ext.apply(this, {
					fieldLabel: GO.projects.lang.type,
					store:GO.projects.incomeTypesStore,
					valueField:'name',
					displayField:'name',
					mode: 'local',
					triggerAction: 'all',
					editable: true,
					allowBlank:false,
					forceSeleciton:false
				});

				GO.form.ComboBox.superclass.initComponent.call(this);
			},

			afterRender:function(){
				GO.form.ComboBoxReset.superclass.afterRender.call(this);

				if(!GO.projects.incomeTypesStore.loaded)
					GO.projects.incomeTypesStore.load();
			}
		});



GO.projects.IncomeTypes = function(config){
	if(!config)
	{
		config = {};
	}

	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.title=GO.projects.lang.incomeTypes;

	config.store =GO.projects.incomeTypesStore;

	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[	{
			header: GO.lang.strName,
			dataIndex: 'name',
			editor: new Ext.form.TextField({
				allowBlank: false
			})
		}]
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	config.clicksToEdit=1;


	var IncomeType = Ext.data.Record.create([
	// the "name" below matches the tag name to read, except "availDate"
	// which is mapped to the tag "availability"
	{
		name: 'id',
		type: 'int'
	},

	{
		name: 'name',
		type: 'string'
	}]);


	config.tbar=[{
		iconCls: 'btn-add',
		text: GO.lang['cmdAdd'],
		cls: 'x-btn-text-icon',
		handler: function(){
			var e = new IncomeType({
				id: '0',
				name:''
			});
			this.stopEditing();
			this.store.insert(0, e);
			this.startEditing(0, 0);
		},
		scope: this
	},{
		iconCls: 'btn-delete',
		text: GO.lang['cmdDelete'],
		cls: 'x-btn-text-icon',
		handler: function(){
			var selectedRows = this.selModel.getSelections();
			for(var i=0;i<selectedRows.length;i++)
			{
				selectedRows[i].commit();
				this.store.remove(selectedRows[i]);
			}
		},
		scope: this
	}
	/*
	,'-',{
		iconCls:'btn-save',
		text:GO.lang.cmdSave,
		handler:function(){
			this.getEl().mask(GO.lang.waitMsgLoad);

			Ext.Ajax.request({
				url:GO.settings.modules.projects.url+'action.php',
				params:{
					task:'save_income_types',
					income_types:Ext.encode(this.getGridData())
				},
				callback:function(options, success, response){

					var result = Ext.decode(response.responseText);

					if(result.new_incomes)
					{
						this.setIds(result.new_incomes);
					}
					this.store.commitChanges();
					this.getEl().unmask();

				},
				scope:this
			});
		},
		scope:this
	}
*/
];
	GO.projects.IncomeTypes.superclass.constructor.call(this, config);

};
Ext.extend(GO.projects.IncomeTypes, Ext.grid.EditorGridPanel,{

	afterRender : function(){

		if(!GO.projects.incomeTypesStore.loaded)
				GO.projects.incomeTypesStore.load();

		GO.projects.IncomeTypes.superclass.afterRender.call(this);
	},
	onShow : function(){
		if(!this.store.loaded){
			this.store.load();
		}
		GO.projects.IncomeTypes.superclass.onShow.call(this);
	},
	getGridData : function(){

		var data = {};

		for (var i = 0; i < this.store.data.items.length;  i++)
		{
			var r = this.store.data.items[i].data;

			data[i]={};

			for(var key in r)
			{
				data[i][key]=r[key];
			}
		}

		return data;
	},
	setIds : function(ids)
	{
		for(var index in ids)
		{
			if(index!="remove")
			{
				this.store.getAt(index).set('id', ids[index]);
			}
		}
	}
});
