GO.projects.MainPanel = function(config){
	
	if(!config)
	{
		config = {};
	}

	config.id=config.id || Ext.id();

	var navData = [
	['pm_nav_projects', GO.projects.lang.projects]
	];

	this.projectsView = new GO.projects.ProjectsView({
		layout:'fit',
		border: false,
		id:config.id+'-projects-view'
	});
	
	

	var cardPanelItems = [
	this.projectsView
	];

	if(GO.timeregistration){
		navData.push(['pm_nav_reports', GO.projects.lang.reports]);
		this.reportPanel = new GO.projects.ReportPanel({
			border: false,
			layout:'fit',
			id:config.id+'-reports'
		});
		cardPanelItems.push(this.reportPanel);
	}

	if(cardPanelItems.length>1){
		this.projectsView.projectsPanel.store.on('load', function(){
			this.navMenu.getSelectionModel().selectFirstRow();
		}, this, {
			single:true
		});


		var navStore = new Ext.data.SimpleStore({
			fields: ['dom_id', 'name'],
			data : navData
		});
	
		this.navMenu= new GO.grid.GridPanel({
			cls:'go-grid3-hide-headers',
			height:60,
			split:true,
//			title:GO.lang.menu,
			region:'north',
			border:true,
			loadMask:true,
			sm:new Ext.grid.RowSelectionModel({
				single:true
			}),
			store: navStore,
			viewConfig: {
				forceFit:true,
				autoFill: true
			},
			columns: [
			{
				header: GO.lang.strName, 
				dataIndex: 'name'					
			}				
			]
		});	
		
		this.navMenu.on('rowclick', function(grid, index){
			this.cardPanel.getLayout().setActiveItem(index);
		
			this.treePanel.setDisabled(index!=0);
			this.showMineOnlyField.setDisabled(index!=0);
			//this.filterPanel.showMineOnlyField.setDisabled(index==2);			
		}, this);
	}
	
	this.treePanel = new GO.projects.ProjectsTree({		
		title:GO.projects.lang.projects,
		split:true,
		autoScroll:true,
		region:'center',
		border:true
	});
	
	this.treePanel.on('click', function(node)
	{
		this.treePanel.setProjectID(node.id);
				
		if(node.id > 0)
		{	
			this.projectsView.projectPanel.load(node.id);
		}
	}, this);
	
	this.treePanel.treeLoader.on('load',function(){
		var node = this.treePanel.getNodeById(this.projectsView.projectsPanel.store.baseParams.parent_project_id);
		this.treePanel.getSelectionModel().select(node);
	}, this,{single:true});


	this.projectsView.projectsPanel.on('delete', function()
	{	
		this.treePanel.reloadActiveNode();
	},this);

	this.projectsView.projectsPanel.store.on('load', function(){
		var node = this.treePanel.getNodeById(this.projectsView.projectsPanel.store.baseParams.parent_project_id);
		if(node){
			this.treePanel.getSelectionModel().select(node);
			node.expand();
//			this.projectsView.projectsPanel.setTitle(node.getPath('text'));
		}
	},this);

//	this.filterPanel = new GO.projects.StatusFilterPanel({
//		region:'south',
//		height:200
//	});
	
	this.filterPanel= new GO.grid.MultiSelectGrid({
		id:'pm-status-filter',
		title:GO.projects.lang.statuses,
		region:'south',
		split:true,
		loadMask:true,
		height:200,
		allowNoSelection:true,
		store:GO.projects.statusesStore,
		bbar: [this.showMineOnlyField = new Ext.form.Checkbox({
			boxLabel: GO.projects.lang.showMineOnly,
			labelSeparator: '',
			name: 'show_mine_only',
			allowBlank: true,
			ctCls:'pm-show-mine-only-cb'
		})]
	});
	
	GO.projects.statusesStore.on('load',function(store,records,options){
		this.showMineOnlyField.setValue(!GO.util.empty(store.reader.jsonData.showMineOnly));
	},this);
	
	this.showMineOnlyField.on('check', function(checkBox,checked){
		this.projectsView.projectsPanel.store.baseParams.showMineOnly = checked;
		this.projectsView.projectsPanel.store.load({
			callback:function(){
				var activeNode = this.treePanel.getNodeById('0');
				activeNode.reload();
			},
			scope: this
		});
//		delete this.projectsView.projectsPanel.store.baseParams.showMineOnly;
		//delete this.projectsView.projectsPanel.store.baseParams.statuses;

		if(this.reportPanel)
			this.reportPanel.reportGrid.store.loaded=false;
	},this);
	
	this.filterPanel.on('change', function(grid, statuses, records)
	{
		var showMineOnly=this.showMineOnlyField.getValue();
		var report_panel_id='';
		if(this.reportPanel){
			report_panel_id=this.reportPanel.id;
		}
		
		this.projectsView.projectsPanel.store.baseParams[grid.id] = Ext.encode(statuses);
		if(this.reportPanel)
			this.reportPanel.reportGrid.store.baseParams["statuses"] = Ext.encode(statuses);

		switch(this.cardPanel.getLayout().activeItem.id)
		{
			case report_panel_id:
//				this.reportPanel.reportGrid.store.baseParams[grid.id] = Ext.encode(statuses);
				this.reportPanel.loadReport();
//				delete this.reportPanel.reportGrid.store.baseParams.statuses;
				
				//this.timeSheet.store.loaded=false;
				this.projectsView.projectsPanel.store.loaded=false;
				break;

			default:
				//this.projectsView.projectsPanel.store.baseParams[grid.id] = Ext.encode(statuses);
				this.projectsView.projectsPanel.store.baseParams.showMineOnly = showMineOnly;
				this.projectsView.projectsPanel.store.load({
					callback:function(){
						var activeNode = this.treePanel.getNodeById('0');
						activeNode.reload();
					},
					scope: this
				});
				delete this.projectsView.projectsPanel.store.baseParams.showMineOnly;
				//delete this.projectsView.projectsPanel.store.baseParams.statuses;

				if(this.reportPanel)
					this.reportPanel.reportGrid.store.loaded=false;
				//this.timeSheet.store.loaded=false;
				break;
		}		
	}, this);
	
	var items = [];
	
	if(this.navMenu)
		items.push(this.navMenu);

	items.push(this.treePanel, this.filterPanel);

	var westPanel = new Ext.Panel({
		id:config.id+'-west',
		region:'west',
		layout:'border',
		border:false,
		split:true,
		width:230,		
		items:items,
		collapsible:true,
		collapseMode:'mini',
		header:false
	});


	this.cardPanel = new Ext.Panel({
		region:'center',
		layout:'card',
		border:false,
		activeItem: 0,
		layoutConfig: {
			deferredRender: true
		},
		items:cardPanelItems
	
	});

	config.items=[
	westPanel,
	this.cardPanel,
	this.projectsView.projectPanel
	];	
	
	if(GO.settings.modules.projects.write_permission)
	{
		var items = [{
	    xtype:'htmlcomponent',
			html:GO.projects.lang.name,
			cls:'go-module-title-tbar'
		}];

		items.push({
			iconCls:'btn-settings',
			text:GO.lang.administration,
			handler:function(){
				if(!this.settingsDialog)
				{
					this.settingsDialog = new GO.projects.SettingsDialog();
				}
				this.settingsDialog.show();
			},
			scope:this
		});

		items.push({
			iconCls:'btn-actions',
			text:GO.projects.lang.batchReports,
			handler:function(){
				if(!this.reportsDialog)
				{
					this.reportsDialog = new GO.projects.ReportsDialog();
				}
				this.reportsDialog.show();
			},
			scope:this
		});

		if(GO.billing){
			items.push({
				iconCls:'btn-add',
				text:GO.projects.lang.bill,
				handler:function(){
					if(!GO.projects.invoiceDialog)
					{
						GO.projects.invoiceDialog= new GO.projects.InvoiceDialog();
					}
					GO.projects.invoiceDialog.show({
						project_id:0
					});
				},
				scope:this
			});
		}

		if (GO.timeregistration || GO.hoursapproval) {
			this.timeregistrationMenu = new Ext.menu.Menu({});

			if (GO.timeregistration)
				this.timeregistrationMenu.add({
						iconCls:'btn-email',
						text:GO.projects.lang.remindForTimeregistration,
						handler:function(){
							if(!this.remindDialog){
								this.remindDialog = new GO.projects.RemindDialog();
							}
							this.remindDialog.show({
								task:'remind_timeregistration_users'
							});
						},
						scope:this
					});

			if (GO.hoursapproval)
				this.timeregistrationMenu.add({
					iconCls:'btn-email',
					text:GO.projects.lang.remindForApproval,
					handler:function(){
						if(!this.remindDialog){
							this.remindDialog = new GO.projects.RemindDialog();
						}
						this.remindDialog.show({
							task:'remind_hoursapproval_users'
						});
					},
					scope:this
				});

			if (GO.hoursapproval)
				this.timeregistrationMenu.add({
					iconCls:'btn-close',
					text:GO.projects.lang['openCloseWeek'],
					handler:function(){
						GO.hoursapproval.showSetWeekDialog();
					},
					scope:this
				})

			items.push({
				iconCls: 'btn-settings',
				text:GO.timeregistration.lang['name'],
				menu: this.timeregistrationMenu
			});
		}

		config.tbar = new Ext.Toolbar({
			cls:'go-head-tb',
			items:items
		});	
	}

	config.border=false;
	config.layout='border';
	GO.projects.MainPanel.superclass.constructor.call(this, config);	
};

Ext.extend(GO.projects.MainPanel, Ext.Panel, {

	refresh : function(){
		GO.projects.statusesStore.load();
		this.projectsView.projectsPanel.store.load();
		this.treePanel.rootNode.reload();
	},

	afterRender : function(){

		GO.projects.MainPanel.superclass.afterRender.call(this);
		GO.projects.statusesStore.load();		
		this.treePanel.setActiveGridStore(this.projectsView.projectsPanel.store, this.projectsView.projectsPanel.searchField);	

		GO.dialogListeners.add('project',{
			scope:this,
			save:function(e, project_id, parent_project_id){
				this.projectsView.projectsPanel.store.reload();
				this.treePanel.project_id = parent_project_id;
				this.treePanel.reloadActiveNode();
			}
		});
	}
});

GO.projects.showProjectDialog = function(project_id){

	if(!GO.projects.projectDialog)
		GO.projects.projectDialog = new GO.projects.ProjectDialog();

	GO.projects.projectDialog.show(project_id);
}

/*
 * This will add the module to the main tabpanel filled with all the modules
 */
 
GO.moduleManager.addModule('projects', GO.projects.MainPanel, {
	title : GO.projects.lang.projects,
	iconCls : 'go-tab-icon-projects'
});

GO.linkPreviewPanels["GO_Projects_Model_Project"]=function(config){
	config = config || {};
	return new GO.projects.ProjectPanel(config);
}

/*
 * If your module has a linkable item, you should add a link handler like this. 
 * The index (no. 1 in this case) should be a unique identifier of your item.
 * See classes/base/links.class.inc for an overview.
 * 
 * Basically this function opens a project window when a user clicks on it from a 
 * panel with links. 
 */
GO.linkHandlers["GO_Projects_Model_Project"]=function(id){
	if(!GO.projects.linkWindow){
		var projectPanel = new GO.projects.ProjectPanel();
		GO.projects.linkWindow = new GO.LinkViewWindow({
			title: GO.projects.lang.project,
			projectPanel: projectPanel,
			items: projectPanel,
			width:600,
			closeAction:"hide"
		});
	}
	GO.projects.linkWindow.show();
	GO.projects.linkWindow.projectPanel.load(id);
	return GO.projects.linkWindow;
}

//GO.newMenuItems.push({
//	text: GO.projects.lang.project,
//	iconCls: 'go-model-icon-GO_Projects_Model_Project',
//	handler:function(item, e){
//		GO.projects.showProjectDialog({
//			link_config: item.parentMenu.link_config
//		});
//	}
//});


