GO.projects.NavigationPanel = function(config){
	config = config || {};

	var now = new Date();

	config.store = new GO.data.JsonStore({
		url : config.url,
		baseParams : {
			task : 'get_weeks',
			year: now.format('Y')
		},
		root : 'results',
		id : 'value',
		totalProperty : 'total',
		fields : ['value', 'text', 'closed','status', 'now'],
		remoteSort : true
	});

	config.store.on('load',function(){
		this.rightArrow.setDisabled(this.store.baseParams.year>now.format('Y'));
	}, this);

	config.tbar=[this.leftArrow = new Ext.Button({
				iconCls : 'btn-left-arrow',
				handler : function() {
					this.store.baseParams.year--;
					this.yearPanel.body.update(this.store.baseParams.year);
					this.store.load();
				},
				scope : this
			}), this.yearPanel = new Ext.Panel({
						html : now.format('Y')+"",
						plain : true,
						border : true,
						cls : 'cal-period'
					}), this.rightArrow = new Ext.Button({
				iconCls : 'btn-right-arrow',
				handler : function() {
					this.store.baseParams.year++;
					this.yearPanel.body.update(this.store.baseParams.year);
					this.store.load();
				},
				scope : this
			})];

	config.cls='go-grid3-hide-headers';
	
	config.columns = [{
				header : GO.lang.strWeek,
				dataIndex : 'text',
				renderer:function(v, meta, record){
					if(record.get('closed')=='') {
						switch(record.get('status')){
							case -1:
								meta.css='go-icon-empty';
								break;
							case 0:
								meta.css='go-icon-warning';
								break;
							case 1:
								meta.css='go-icon-ok';
								break;
							case 2:
								meta.css='go-icon-exclamation';
								break;
							default:
								meta.css='go-icon-empty';
						}
					} else {
						meta.css=(record.get('closed')==1) ? 'go-icon-ok' : 'go-icon-empty';
					}

					return v;
				}
			}];

	config.view = new Ext.grid.GridView({
				autoFill : true,
				forceFit : true
			});
	config.sm = new Ext.grid.RowSelectionModel({
		single:true
	});
	config.loadMask = true;

	GO.projects.NavigationPanel.superclass.constructor.call(this, config);
}

Ext.extend(GO.projects.NavigationPanel, GO.grid.GridPanel, {
	
	selectNow : function(){
		var index = this.store.findBy(function(record){
			return record.data.now;				
		});

		if(!index){
			this.getSelectionModel().selectFirstRow();
		}else
		{
			this.getSelectionModel().selectRow(index);			
			this.getView().focusRow.defer(10,this.getView(),[index]);
		}
	}
	
});