/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ProjectReportPanel.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.ProjectReportPanel = function(config){
	if(!config)
	{
		config = {};
	}
	config.title = GO.projects.lang.reportTemplates;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	var fields ={
		fields:['id','user_name','name','fields'],
		columns:[{
			header: GO.lang.strName,
			dataIndex: 'name'
		}]
	};
	config.store = new GO.data.JsonStore({
	    url: GO.settings.modules.projects.url+ 'json.php',
	    baseParams: {
	    	task: 'report_templates'
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: fields.fields,
	    remoteSort: true
	});
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:fields.columns
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	GO.projects.ReportTemplatesGrid.superclass.constructor.call(this, config);
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);
		document.location=GO.settings.modules.projects.url+'report.php?report_template_id='+record.id+'&project_id='+this.ownerCt.ownerCt.project_id;
		}, this);
};
Ext.extend(GO.projects.ProjectReportPanel, GO.grid.GridPanel,{
	onShow : function(){
		GO.projects.ProjectReportPanel.superclass.onShow.call(this);
		if(!this.store.loaded)
		{
			this.store.load();
		}
	}
});
