GO.projects.ProjectsView = Ext.extend(Ext.Panel, {
	
	initComponent : function(){
		
		this.layout='border';
		
		this.projectsPanel = new GO.projects.ProjectsPanel({
//			title:GO.projects.lang.projects,
			cls:'go-white-bg',
			layout:'fit',
			border: true,
			region:'center',
			split:true,
			tbar: [{
				xtype:'quickeditbutton',
				handler: function(b) {
//					if (!GO.projects.projectsEditDialog) {
						var colDataIds = GO.base.QuickEditDialog.getValidColDataIds(this.projectsPanel.fields.columns);
						colDataIds.push('icon');
						var editStoreFields = GO.base.QuickEditDialog.cloneArrayValid(this.projectsPanel.store.fields.items,colDataIds,'name');
						var editGridColumns = GO.base.QuickEditDialog.cloneArrayValid(this.projectsPanel.fields.columns,colDataIds,'dataIndex');
						editStoreFields.splice(2,0,new Ext.data.Field({
							name : 'description'
						}));
						editGridColumns.splice(2,0,new Ext.grid.Column({
							header: GO.lang.strDescription,
							dataIndex: 'description',
							width: 150,
							sortable:true,
							editor: new Ext.form.TextArea()
						}));
//						var editStoreFields = GO.util.clone(this.projectsPanel.store.fields.items);
//						var editGridColumns = GO.base.QuickEditDialog.cloneColumns(this.projectsPanel.fields.columns);
						GO.projects.projectsEditDialog = new GO.base.QuickEditDialog({
							closeAction:'close',
							baseParams:{
								query:this.projectsPanel.store.baseParams.query,
								parent_project_id:this.projectsPanel.store.baseParams.parent_project_id
							},
							'editorGridParams' : {
								'modelName' : 'project',
								'moduleName' : 'projects',
								'storeFields' : editStoreFields,
								'gridColumns' : editGridColumns,
								'requiredFields' : ['name'],
								'replaceFieldsOnSubmit' : {
									'status_name' : 'status_id',
									'type_name' : 'type_id',
									'template_name' : 'template_id',
									'contact' : 'contact',
									'customer' : 'customer',
									'responsible_user_name' : 'responsible_user_id'
								}
							}
						});
						GO.projects.projectsEditDialog.on('save',function(){
							this.projectsPanel.store.load();
						},this);
//					}
					
					GO.projects.projectsEditDialog.store.baseParams.parent_project_id=this.projectsPanel.store.baseParams.parent_project_id;
					//GO.projects.projectsEditDialog.setMasterParams({parent_project_id:this.projectsPanel.store.baseParams.parent_project_id});

					if (!GO.util.empty(this.projectsPanel.store.baseParams['pm-status-filter']))
						var baseParams = {'pm-status-filter':this.projectsPanel.store.baseParams['pm-status-filter']};
					else
						var baseParams = {};

					GO.projects.projectsEditDialog.show({baseParams: baseParams});
					
					var sortState = this.projectsPanel.store.getSortState();
					GO.projects.projectsEditDialog.store.singleSort(sortState['field'],sortState['direction']);

				},
				scope: this
			},
			'-']
		});
		
		this.projectsPanel.on("delayedrowselect",function(grid, rowIndex, r){
			this.projectPanel.load(r.id);			
		}, this);
		
		this.projectsPanel.on('rowdblclick', function(grid){
			var selectionModel = grid.getSelectionModel();
			var record = selectionModel.getSelected();
			
			this.projectsPanel.store.baseParams.parent_project_id=record.id;
			this.projectsPanel.store.load();
						
		}, this);

		this.projectPanel = new GO.projects.ProjectPanel({
//			title:GO.projects.lang.projectInfo,
			region: 'east',
			width: 460,
			split:true,
			id:this.id+'_east',
			collapseMode:'mini',
			hideCollapseTool:true,
			collapsible:true
		});
		
		this.items = [this.projectsPanel];
		
		GO.projects.ProjectsView.superclass.initComponent.call(this);
	},
	
	onShow : function() {
		GO.projects.ProjectsView.superclass.onShow.call(this);

		if (!this.projectsPanel.store.loaded)
			this.projectsPanel.store.load();
	}
	
});