GO.projects.ReportGrid = function(config){
	
	if(!config)
	{
		config = {};
	}
	
	
	config.store = new GO.data.JsonStore({
		url: GO.settings.modules.projects.url+'json.php',
		baseParams: {
			'task': 'report'
			},
		root: 'results',
		fields:['name', 'units', 'days','int_fee_value','ext_fee_value', 'profit', 'user_id', 'customer', 'project_id', 'units_budget', 'units_diff', 'expenses','income'],
		remoteSort:true
	});

	//config.cls='pm-report-table',
	config.paging=true;
	config.columns=[
		{
			header:GO.lang['strName'],
			dataIndex: 'name',
			sortable:true,
			hideable:false,
			id:'name'
		},{
			header:GO.projects.lang.units,
			dataIndex: 'units',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.totalBudget,
			dataIndex: 'units_budget',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.totalDiff,
			dataIndex: 'units_diff',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.lang.strDays,
			dataIndex: 'days',
			sortable:true,
			align:'right',
			width:70
		}];
		
	if(GO.settings.modules.projects.write_permission)
	{
		config.columns.splice(config.columns.length,0,{
			header:GO.projects.lang.internalFee,
			dataIndex: 'int_fee_value',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.externalFee,
			dataIndex: 'ext_fee_value',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.profit,
			dataIndex: 'profit',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.expenses,
			dataIndex: 'expenses',
			sortable:true,
			align:'right',
			width:70
		},{
			header:GO.projects.lang.income,
			dataIndex: 'income',
			sortable:true,
			align:'right',
			width:70
		});
	}
	
	config.view=new Ext.grid.GridView({
		emptyText: GO.projects.lang.noData		
	});

	config.autoExpandColumn='name';
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;	
	
	GO.projects.ReportGrid.superclass.constructor.call(this, config);
	
};

Ext.extend(GO.projects.ReportGrid, GO.grid.GridPanel, {
	
	afterRender : function()
	{
		GO.projects.ReportGrid.superclass.afterRender.call(this);		
		
    this.on("rowdblclick", function(grid, rowClicked, e){ 
			if(!this.hoursDialog)
    	{
    		this.hoursPanel = new GO.projects.HoursGrid({border:false});
    		
    		this.hoursDialog = new Ext.Window({
    			title: GO.projects.lang.timeTracking,
    			width:600,
    			height:400,
    			layout:'fit',			
    			items:this.hoursPanel,
					stateId:'pm-report-hours-dialog',
    			closeAction:'hide',
    			buttons:[{
						text: GO.lang['cmdClose'],
						handler: function(){
							this.hoursDialog.hide();
              this.store.reload();
						},
						scope:this
					}
				]
    		});
    	} 
    	
    	var selModel = grid.getSelectionModel();
    	var record = selModel.getSelected();
    	if(!record.data[this.store.baseParams.group_by])
    	{
    		//alert('No data for this record');
    	}else
    	{	    
    		this.hoursPanel.store.baseParams={'task': 'hours'};
	    	this.hoursPanel.store.baseParams.start_date = this.store.baseParams.start_date;
	    	this.hoursPanel.store.baseParams.end_date = this.store.baseParams.end_date;
	    	this.hoursPanel.store.baseParams.user_id = this.store.baseParams.user_id;
				this.hoursPanel.store.baseParams.query = this.store.baseParams.query;
	    		
	  		this.hoursPanel.store.baseParams[this.store.baseParams.group_by]=record.data[this.store.baseParams.group_by];
	  		this.hoursPanel.store.load();
	  		  		
	    	this.hoursDialog.show();    	
    	}	
		}, this);
    
	}
});
