/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: ReportPagesGrid.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.ReportPagesGrid = function(config){
	if(!config)
	{
		config = {};
	}
	config.title = GO.projects.lang.reportPages;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.disabled=true;
	var fields ={
		fields:['id','report_template_id','sort_order','title','subtitle'],
		columns:[	{
			header: GO.projects.lang.title, 
			dataIndex: 'title'
		}]
	};
	config.store = new GO.data.JsonStore({
	    url: GO.settings.modules.projects.url+ 'json.php',
	    baseParams: {
	    	task: 'report_pages',
				report_template_id:0
	    	},
	    root: 'results',
	    id: 'id',
	    totalProperty:'total',
	    fields: fields.fields,
	    remoteSort: true
	});
	config.paging=true;

	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:fields.columns
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	this.reportPageDialog = new GO.projects.ReportPageDialog();
		this.reportPageDialog.on('save', function(){   
			this.store.reload();	    			    			
		}, this);
	config.tbar=[{
			iconCls: 'btn-add',							
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
	    	this.reportPageDialog.show();
			},
			scope: this
		},{
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		}];
	GO.projects.ReportPagesGrid.superclass.constructor.call(this, config);
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);	
		this.reportPageDialog.show(record.data.id);
		}, this);
};
Ext.extend(GO.projects.ReportPagesGrid, GO.grid.GridPanel,{

	onShow : function(){
		GO.projects.ReportPagesGrid.superclass.onShow.call(this);
		if(!this.store.loaded)
		{
			this.store.load();
		}
	},

	setReportTemplateId : function(report_template_id){
		this.store.baseParams.report_template_id=report_template_id;
		this.setDisabled(report_template_id==0);
		this.reportPageDialog.formPanel.baseParams.report_template_id=report_template_id;
		this.store.removeAll();
		this.store.loaded=false;
	}
});
