/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ReportsDialog.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.ReportsDialog = function(config){
	if(!config)
	{
		config={};
	}

	this.reportPanel = new GO.projects.CustomReportsGrid();

	config.collapsible=true;
	config.maximizable=true;
	config.layout='fit';
	config.modal=false;
	config.resizable=true;
	config.width=750;
	config.height=500;
	config.closeAction='hide';
	config.title= GO.projects.lang.customReports;
	config.items= [this.reportPanel];

	config.buttons=[{
		text: GO.lang['cmdClose'],
		handler: function(){
			this.hide();
		},
		scope:this
	}
	];
	GO.projects.ReportsDialog.superclass.constructor.call(this, config);
}
Ext.extend(GO.projects.ReportsDialog, Ext.Window,{
	show : function (project_id, files_folder_id) {
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}
		if(!project_id)
		{
			project_id=0;
		}
		
		this.reportPanel.setProjectId(project_id, files_folder_id);
		
		GO.projects.ReportsDialog.superclass.show.call(this);		
	}
});
