GO.projects.SelectTemplateWindow = Ext.extend(GO.Window, {

	initComponent : function(){

		this.list = new GO.grid.SimpleSelectList(
			{store: GO.projects.templatesStore}
		);			

		this.list.on('click', function(dataview, index){
			this.showConfig.template_id= dataview.store.data.items[index].id;
			this.list.clearSelections();
			GO.projects.projectDialog.show(this.showConfig);
			this.hide();
   	},this);

		Ext.apply(this, {
			title: GO.projects.lang.selectTemplate,
			layout:'fit',
			closable:true,
			closeAction:'hide',
			modal:false,
			height:400,
			width:600,
			items: new Ext.Panel({
				items: this.list,
				autoScroll:true,
				cls: 'go-form-panel'
			})
		});


		GO.projects.SelectTemplateWindow.superclass.initComponent.call(this);
	},

	show : function(config){

		if(!this.rendered)
			this.render(Ext.getBody());

		this.showConfig = config || {};

		if(!this.list.store.loaded)
		{
			this.list.store.load({
				scope:this,
				callback:function(){
					this.show(this.showConfig);
				}
			});
		}else
		{
			if(!this.list.store.getCount()){
				this.showConfig.template_id=0;
				GO.projects.projectDialog.show(this.showConfig);
			}else if(this.list.store.getCount()==1)
			{
				var records = this.list.store.getRange(0,1);
				this.showConfig.template_id=records[0].get('id');
				GO.projects.projectDialog.show(this.showConfig);
				
			}else
			{
				GO.projects.SelectTemplateWindow.superclass.show.call(this);
			}
		}
	}

});