/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: StatusDialog.js 16606 2013-08-19 08:21:12Z wvbeusekom $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 * @author Wilmar van Beusekom <wilmar@intermesh.nl>
 */
GO.projects.StatusDialog = function(config){
	if(!config)
	{
		config={};
	}
	this.buildForm();
	var focusFirstField = function(){
		this.formPanel.items.items[0].focus();
	};
	config.collapsible=false;
	config.maximizable=false;
	config.layout='fit';
	config.modal=false;
	config.resizable=false;
	config.width=300;
	config.autoHeight=true;
	config.closeAction='hide';
	config.title= GO.projects.lang.status;					
	config.items= this.formPanel;
	config.focus= focusFirstField.createDelegate(this);
	config.buttons=[{
			text: GO.lang['cmdOk'],
			handler: function(){
				this.submitForm(true);
			},
			scope: this
		},{
			text: GO.lang['cmdClose'],
			handler: function(){
				this.hide();
			},
			scope:this
		}					
	];
	GO.projects.StatusDialog.superclass.constructor.call(this, config);
	this.addEvents({'save' : true});	
}
Ext.extend(GO.projects.StatusDialog, Ext.Window,{
	show : function (status_id, config) {
		if(!this.rendered)
		{
			this.render(Ext.getBody());
		}

		if(!status_id)
		{
			status_id=0;			
		}
		this.setStatusId(status_id);
		this.nStatuses = config.nStatuses;
		if(this.status_id>0)
		{
			this.formPanel.load({
				url: GO.url('projects/status/load'),
				waitMsg:GO.lang['waitMsgLoad'],
				success:function(form, action)
				{
					GO.projects.StatusDialog.superclass.show.call(this);
				},
				failure:function(form, action)
				{
					GO.errorDialog.show(action.result.feedback)
				},
				scope: this
			});
		}else 
		{
			this.formPanel.form.reset();
			GO.projects.StatusDialog.superclass.show.call(this);
		}
	},
	setStatusId : function(status_id)
	{
		this.formPanel.form.baseParams['id']=status_id;
		this.status_id=status_id;
	},
	submitForm : function(hide){
		this.formPanel.form.submit(
		{
			url: GO.url('projects/status/submit'),
			params: {
				'sort_order' : (parseInt(this.nStatuses) + 1)
			},
			waitMsg:GO.lang['waitMsgSave'],
			success:function(form, action){
				this.fireEvent('save', this);
				if(hide)
				{
					this.hide();	
				}else
				{
					if(action.result.status_id)
					{
						this.setStatusId(action.result.status_id);
					}
				}
			},		
			failure: function(form, action) {
				if(action.failureType == 'client')
				{					
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);			
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});
	},
	buildForm : function () {
		
    this.formPanel = new Ext.form.FormPanel({
	    waitMsgTarget:true,
			url: GO.url('projects/status/load'),
			baseParams: {},
			border: false,
			autoHeight:true,
			cls:'go-form-panel',
			items:[{
				xtype: 'textfield',
			  name: 'name',
				anchor: '100%',
			  fieldLabel: GO.lang.strName
			},{
				xtype:'xcheckbox',
				name:'show_in_tree',
				hideLabel: true,
				boxLabel:GO.projects.lang.showInTree
			}]
		});
	}
});
