GO.projects.StatusFilterPanel = function(config)
{
	if(!config)
	{
		config = {};
	}

	var checkColumn = new GO.grid.CheckColumn({
		header: '&nbsp;',
		dataIndex: 'checked',
		width: 30
	});

	

	if(!config.store)
		config.store=GO.projects.statusesStore;

	config.store.on('load', function(){
		this.showMineOnlyField.setValue(!GO.util.empty(this.store.reader.jsonData.show_mine_only));

	}, this);
	
	Ext.apply(config, {
		cls:'go-grid3-hide-headers',
		autoScroll:true,
		border:true,
		layout:'fit',
		split:true,
		loadMask:true,
		collapsible:true,
		collapseMode:'mini',
		header:false,
		columns: [
				checkColumn,
				{
					header: GO.lang.strName, 
					dataIndex: 'name',
					id:'name'
				}				
			],
		plugins: [checkColumn],
		autoExpandColumn:'name'
	});
	

	config.tbar=[this.showMineOnlyField = new Ext.form.Checkbox({
				boxLabel: GO.projects.lang.showMineOnly,
				labelSeparator: '',
				name: 'show_mine_only',
				allowBlank: true,
				ctCls:'pm-show-mine-only-cb'
			})];

	
	var applyButton = new Ext.Button({
		text:GO.lang.cmdApply,
		handler:function(){
			
			var statuses = [];
			
			for (var i = 0; i < this.store.data.items.length;  i++)
			{
				var checked = this.store.data.items[i].get('checked');
				if(checked=="1")
				{
					statuses.push(this.store.data.items[i].get('id'));
				}				
			}
			
			this.fireEvent('change', this, statuses, this.showMineOnlyField.getValue());
			
			this.store.commitChanges();
		},
		scope: this
	});
	
	config.buttons=[applyButton];
	config.layout='fit';
	
	
	GO.projects.StatusFilterPanel.superclass.constructor.call(this, config);
	
	this.addEvents({change : true});
}

Ext.extend(GO.projects.StatusFilterPanel, GO.grid.GridPanel);