/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: TemplateEventPanel.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.TemplateEventPanel = Ext.extend(GO.DisplayPanel,{
	link_type : 0,
	loadParams : {task: 'template_event_with_items'},
	idParam : 'template_event_id',
	loadUrl : GO.settings.modules.projects.url+'json.php',
	editHandler : function(){
		GO.projects.template_eventDialog.show({ template_event_id: this.link_id});
		this.addSaveHandler(GO.projects.template_eventDialog);
	},
	initComponent : function(){
		this.template =
				'<table class="display-panel" cellpadding="0" cellspacing="0" border="0">'+
					'<tr>'+
						'<td colspan="2" class="display-panel-heading">Information</td>'+
					'</tr>'+
									'<tpl if="!GO.util.empty(template_id)">'+
						'<tr>'+
							'<td>'+GO.projects.lang.templateId+':</td><td>{template_id}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(name)">'+
						'<tr>'+
							'<td>'+GO.lang.strName+':</td><td>{name}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(description)">'+
						'<tr>'+
							'<td>'+GO.lang.strDescription+':</td><td>{description}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(time_offset)">'+
						'<tr>'+
							'<td>'+GO.projects.lang.timeOffset+':</td><td>{time_offset}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(duration)">'+
						'<tr>'+
							'<td>'+GO.projects.lang.duration+':</td><td>{duration}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(type)">'+
						'<tr>'+
							'<td>'+GO.projects.lang.type+':</td><td>{type}</td>'+
						'</tr>'+
					'</tpl>'+

					'<tpl if="!GO.util.empty(reminder)">'+
						'<tr>'+
							'<td>'+GO.projects.lang.reminder+':</td><td>{reminder}</td>'+
						'</tr>'+
					'</tpl>'+

				'</table>';																		
		this.xtemplate = new Ext.XTemplate(this.template, this.templateConfig);
		GO.projects.TemplateEventPanel.superclass.initComponent.call(this);
	}
});			
