/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @version $Id: TypesGrid.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */
GO.projects.TypesGrid = function(config){
	if(!config)
	{
		config = {};
	}
	config.title = GO.projects.lang.types;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.store = GO.projects.typesStore;
	config.paging=true;
	var columnModel =  new Ext.grid.ColumnModel({
		defaults:{
			sortable:true
		},
		columns:[
	   		{
			header: GO.lang.strName, 
			dataIndex: 'name'
		}
	]
	});
	
	config.cm=columnModel;
	config.view=new Ext.grid.GridView({
		autoFill: true,
		forceFit: true,
		emptyText: GO.lang['strNoItems']		
	});
	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	this.searchField = new GO.form.SearchField({
		store: config.store,
		width:320
	});
	

	config.tbar=[{
			iconCls: 'btn-add',							
			text: GO.lang['cmdAdd'],
			cls: 'x-btn-text-icon',
			handler: function(){
	    	this.showTypeDialog();
			},
			scope: this
		},{
			iconCls: 'btn-delete',
			text: GO.lang['cmdDelete'],
			cls: 'x-btn-text-icon',
			handler: function(){
				this.deleteSelected();
			},
			scope: this
		},'-',this.searchField];
	GO.projects.TypesGrid.superclass.constructor.call(this, config);
	this.on('rowdblclick', function(grid, rowIndex){
		var record = grid.getStore().getAt(rowIndex);	
		this.showTypeDialog(record.data.id);
		}, this);
};
Ext.extend(GO.projects.TypesGrid, GO.grid.GridPanel,{
	afterRender : function()
	{
		GO.projects.TypesGrid.superclass.afterRender.call(this);
		this.store.load();
	},
	showTypeDialog : function(config){
		if(!GO.projects.typeDialog){
		GO.projects.typeDialog = new GO.projects.TypeDialog();
		GO.projects.typeDialog.on('save', function(){
				GO.projects.typesStore.reload();
			}, this);
		}
		GO.projects.typeDialog.show(config);
	}
});
