--
-- Tabelstructuur voor tabel `cf_pm_hours`
--

DROP TABLE IF EXISTS `cf_pm_hours`;
CREATE TABLE IF NOT EXISTS `cf_pm_hours` (
  `model_id` int(11) NOT NULL,
  PRIMARY KEY (`model_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `cf_pm_projects`
--

DROP TABLE IF EXISTS `cf_pm_projects`;
CREATE TABLE IF NOT EXISTS `cf_pm_projects` (
  `model_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`model_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------


--
-- Tabelstructuur voor tabel `go_links_pm_projects`
--

DROP TABLE IF EXISTS `go_links_pm_projects`;
CREATE TABLE IF NOT EXISTS `go_links_pm_projects` (
  `id` int(11) NOT NULL,
  `folder_id` int(11) NOT NULL,
  `model_id` int(11) NOT NULL,
  `model_type_id` int(11) NOT NULL,
  `description` varchar(100) DEFAULT NULL,
  `ctime` int(11) NOT NULL,
  PRIMARY KEY `model_id` (`id`,`model_id`,`model_type_id`),
  KEY `id` (`id`,`folder_id`),
  KEY `ctime` (`ctime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------


--
-- Tabelstructuur voor tabel `pm_custom_reports`
--

DROP TABLE IF EXISTS `pm_custom_reports`;
CREATE TABLE IF NOT EXISTS `pm_custom_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `project_id` int(11) NOT NULL,
  `report_template_id` int(11) NOT NULL,
  `start_time` int(11) NOT NULL DEFAULT '0',
  `end_time` int(11) NOT NULL DEFAULT '0',
  `batch` varchar(20) NOT NULL DEFAULT '',
  `query_templates` varchar(255) NOT NULL DEFAULT '',
  `query_fields` varchar(255) NOT NULL DEFAULT '',
  `query` text NULL,
	`adv_query_data` text NULL,
  PRIMARY KEY (`id`),
  KEY `project_id` (`project_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_expenses`
--

DROP TABLE IF EXISTS `pm_expenses`;
CREATE TABLE IF NOT EXISTS `pm_expenses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `project_id` int(11) NOT NULL,
  `type` varchar(100) NOT NULL,
  `amount` double NOT NULL DEFAULT '0',
  `date` int(11) NOT NULL DEFAULT '0',
  `invoice_id` int(11) NOT NULL DEFAULT '0',
  `orig_currency` char(3) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `orig_exchange` double NOT NULL DEFAULT '1',
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `project_id` (`project_id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_expense_types`
--

DROP TABLE IF EXISTS `pm_expense_types`;
CREATE TABLE IF NOT EXISTS `pm_expense_types` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_fees`
--

DROP TABLE IF EXISTS `pm_fees`;
CREATE TABLE IF NOT EXISTS `pm_fees` (
  `id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(50) DEFAULT NULL,
  `external_value` double NOT NULL DEFAULT '0',
  `internal_value` double NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL DEFAULT '0',
  `acl_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_hours`
--

DROP TABLE IF EXISTS `pm_hours`;
CREATE TABLE IF NOT EXISTS `pm_hours` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `project_id` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `date` int(11) NOT NULL DEFAULT '0',
  `units` double NOT NULL DEFAULT '0',
  `comments` text,
  `fee_id` int(11) NOT NULL DEFAULT '0',
  `ext_fee_value` double NOT NULL DEFAULT '0',
  `fee_time` int(11) NOT NULL DEFAULT '0',
  `int_fee_value` double NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `invoice_id` int(11) NOT NULL DEFAULT '0',
  `payout_invoice_id` int(11) NOT NULL DEFAULT '0',
  `ctime` int(11) NOT NULL DEFAULT '0',
  `mtime` int(11) NOT NULL DEFAULT '0',
  `approved_at` INT DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `invoice_id` (`invoice_id`),
  KEY `payout_invoice_id` (`payout_invoice_id`),
  KEY `project_id` (`project_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_incomes`
--

DROP TABLE IF EXISTS `pm_incomes`;
CREATE TABLE IF NOT EXISTS `pm_incomes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `project_id` int(11) NOT NULL,
  `type` varchar(100) NOT NULL DEFAULT '',
  `amount` double NOT NULL DEFAULT '0',
  `date` int(11) NOT NULL DEFAULT '0',
  `orig_currency` char(3) NOT NULL DEFAULT '',
  `orig_exchange` double NOT NULL DEFAULT '1',
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `project_id` (`project_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_income_types`
--

DROP TABLE IF EXISTS `pm_income_types`;
CREATE TABLE IF NOT EXISTS `pm_income_types` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_order_unsummarized_items`
--

DROP TABLE IF EXISTS `pm_order_unsummarized_items`;
CREATE TABLE IF NOT EXISTS `pm_order_unsummarized_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL DEFAULT '0',
  `project_id` int(11) NOT NULL DEFAULT '0',
  `description` text,
  `unit_price` double NOT NULL DEFAULT '0',
  `unit_total` double NOT NULL DEFAULT '0',
  `amount` double NOT NULL DEFAULT '0',
  `vat` double NOT NULL DEFAULT '0',
	`total` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`),
  KEY `project_id` (`project_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_portlet_settings`
--

DROP TABLE IF EXISTS `pm_portlet_statuses`;
CREATE TABLE IF NOT EXISTS `pm_portlet_statuses` (
  `user_id` int(11) NOT NULL,
  `status_id` int(11) NOT NULL,
  PRIMARY KEY (`user_id`,`status_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_statuses`
--

DROP TABLE IF EXISTS `pm_statuses`;
CREATE TABLE IF NOT EXISTS `pm_statuses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `complete` enum('0','1') NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
	`show_in_tree` BOOLEAN NOT NULL DEFAULT '1',
  PRIMARY KEY  (`id`),
  KEY `sort_order` (`sort_order`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_projects`
--

DROP TABLE IF EXISTS `pm_projects`;
CREATE TABLE IF NOT EXISTS `pm_projects` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(100) NOT NULL DEFAULT '',
  `customer` varchar(100) DEFAULT NULL DEFAULT '',
  `description` text,
  `company_id` int(11) NOT NULL DEFAULT '0',
  `ctime` int(11) NOT NULL DEFAULT '0',
  `mtime` int(11) NOT NULL DEFAULT '0',
	`muser_id` int(11) NOT NULL DEFAULT '0',
  `status_id` int(11) NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL DEFAULT '0',
  `parent_project_id` int(11) NOT NULL DEFAULT '0',
  `start_time` int(11) NOT NULL DEFAULT '0',
  `due_time` int(11) NOT NULL DEFAULT '0',
  `units_budget` double NOT NULL DEFAULT '0',
  `select_fee` tinyint(1) NOT NULL DEFAULT '0',
  `contact_id` int(11) NOT NULL DEFAULT '0',
  `contact` varchar(150) DEFAULT NULL,
  `files_folder_id` int(11) NOT NULL DEFAULT '0',
  `responsible_user_id` int(11) NOT NULL DEFAULT '0',
  `template_id` int(11) NOT NULL DEFAULT '0',
  `calendar_id` int(11) NOT NULL DEFAULT '0',
  `event_id` int(11) NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
	`tasklist_id` INT NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `status_id` (`status_id`),
  KEY `type_id` (`type_id`),
  KEY `parent_project_id` (`parent_project_id`),
  KEY `responsible_user_id` (`responsible_user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_report_pages`
--

DROP TABLE IF EXISTS `pm_report_pages`;
CREATE TABLE IF NOT EXISTS `pm_report_pages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `report_template_id` int(11) NOT NULL DEFAULT '0',
  `sort_order` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) NOT NULL DEFAULT '',
  `subtitle` varchar(100) NOT NULL DEFAULT '',
  `content` text NULL,
  `mtime` int(11) NOT NULL DEFAULT '0',
  `landscape` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `report_template_id` (`report_template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabelstructuur voor tabel `pm_report_projects`
--

DROP TABLE IF EXISTS `pm_report_projects`;
CREATE TABLE IF NOT EXISTS `pm_report_projects` (
  `custom_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  PRIMARY KEY (`custom_id`,`project_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------
--
-- Tabelstructuur voor tabel `pm_report_templates`
--

DROP TABLE IF EXISTS `pm_report_templates`;
CREATE TABLE IF NOT EXISTS `pm_report_templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(100) NOT NULL DEFAULT '',
	`type` varchar(3) NOT NULL DEFAULT 'pdf',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabelstructuur voor tabel `pm_report_templates_pdf`
--

DROP TABLE IF EXISTS `pm_report_templates_pdf`;
CREATE TABLE IF NOT EXISTS `pm_report_templates_pdf` (
	`template_id` int(11) NOT NULL DEFAULT '0',
	`fields` varchar(255) NOT NULL DEFAULT '',
  `header` text NULL,
  `footer` text NULL,
  `image` varchar(255) NOT NULL DEFAULT '',
  `img_top` int(11) NOT NULL DEFAULT '0',
  `img_left` int(11) NOT NULL DEFAULT '0',
  `img_width` int(11) NOT NULL DEFAULT '0',
  `img_height` int(11) NOT NULL DEFAULT '0',
  `no_page_breaks` tinyint(1) NOT NULL DEFAULT '0',
  `l_margin` int(11) NOT NULL DEFAULT '30',
  `t_margin` int(11) NOT NULL DEFAULT '60',
  `r_margin` int(11) NOT NULL DEFAULT '30',
  `b_margin` int(11) NOT NULL DEFAULT '30',
  `final_page_template` text NULL,
	PRIMARY KEY (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabelstructuur voor tabel `pm_report_templates_odf`
--

DROP TABLE IF EXISTS `pm_report_templates_odf`;
CREATE TABLE IF NOT EXISTS `pm_report_templates_odf` (
	`template_id` int(11) NOT NULL DEFAULT '0',
	`fields` varchar(255) NOT NULL DEFAULT '',
  `header` text NULL,
  `footer` text NULL,
  `image` varchar(255) NOT NULL DEFAULT '',
  `img_top` int(11) NOT NULL DEFAULT '0',
  `img_left` int(11) NOT NULL DEFAULT '0',
  `img_width` int(11) NOT NULL DEFAULT '0',
  `img_height` int(11) NOT NULL DEFAULT '0',
  `no_page_breaks` tinyint(1) NOT NULL DEFAULT '0',
  `l_margin` int(11) NOT NULL DEFAULT '30',
  `t_margin` int(11) NOT NULL DEFAULT '60',
  `r_margin` int(11) NOT NULL DEFAULT '30',
  `b_margin` int(11) NOT NULL DEFAULT '30',
  `final_page_template` text NULL,
	`odf_extension` varchar(10) NOT NULL DEFAULT '',
	PRIMARY KEY (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------
--
-- Tabelstructuur voor tabel `pm_report_templates_csv`
--

DROP TABLE IF EXISTS `pm_report_templates_csv`;
CREATE TABLE IF NOT EXISTS `pm_report_templates_csv` (
	`template_id` int(11) NOT NULL DEFAULT '0',
	`headers` text NULL,
	`tags` text NULL,
	PRIMARY KEY (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_templates`
--

DROP TABLE IF EXISTS `pm_templates`;
CREATE TABLE IF NOT EXISTS `pm_templates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(50) NOT NULL DEFAULT '',
  `acl_id` int(11) NOT NULL DEFAULT '0',
  `files_folder_id` int(11) NOT NULL DEFAULT '0',
  `fields` varchar(255) NOT NULL DEFAULT '',
  `icon` varchar(255) NOT NULL DEFAULT '',
  `default_status_id` int(11) NOT NULL DEFAULT '0',
  `default_type_id` int(11) NOT NULL DEFAULT '0',
	`show_in_tree` BOOLEAN NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Tabelstructuur voor tabel `pm_templates_events`
--

DROP TABLE IF EXISTS `pm_templates_events`;
CREATE TABLE IF NOT EXISTS `pm_templates_events` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `template_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(100) DEFAULT NULL,
  `description` text,
  `time_offset` int(11) NOT NULL DEFAULT '0',
  `duration` int(11) NOT NULL DEFAULT '0',
  `type` varchar(20) NOT NULL DEFAULT '0',
  `reminder` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL,
  `new_template_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `template_id` (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_template_tabs`
--

DROP TABLE IF EXISTS `pm_template_tabs`;
CREATE TABLE IF NOT EXISTS `pm_template_tabs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `template_id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `sort` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `template_id` (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_template_tabs_cf`
--

DROP TABLE IF EXISTS `pm_template_tabs_cf`;
CREATE TABLE IF NOT EXISTS `pm_template_tabs_cf` (
  `template_tab_id` int(11) NOT NULL,
  `customfield_id` int(11) NOT NULL,
  `sort` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`template_tab_id`,`customfield_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_timers`
--

DROP TABLE IF EXISTS `pm_timers`;
CREATE TABLE IF NOT EXISTS `pm_timers` (
  `project_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `starttime` int(11) NOT NULL,
  KEY `project_id` (`project_id`,`user_id`,`starttime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_types`
--

DROP TABLE IF EXISTS `pm_types`;
CREATE TABLE IF NOT EXISTS `pm_types` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) DEFAULT NULL,
  `user_id` int(11) NOT NULL,
  `acl_id` int(11) NOT NULL DEFAULT '0',
  `acl_book` int(11) NOT NULL DEFAULT '0',
	`files_folder_id` INT NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_user_fees`
--

DROP TABLE IF EXISTS `pm_user_fees`;
CREATE TABLE IF NOT EXISTS `pm_user_fees` (
  `project_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `internal_value` double NOT NULL DEFAULT '0',
  `external_value` double NOT NULL DEFAULT '0',
  PRIMARY KEY (`project_id`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Tabelstructuur voor tabel `pm_weeks`
--

DROP TABLE IF EXISTS `pm_weeks`;
CREATE TABLE IF NOT EXISTS `pm_weeks` (
  `user_id` int(11) NOT NULL,
  `wtime` int(11) NOT NULL,
  PRIMARY KEY (`user_id`,`wtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

DROP TABLE IF EXISTS `pm_standard_tasks`;
CREATE TABLE IF NOT EXISTS `pm_standard_tasks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `units` double NOT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;