GO.projects2.RemindDialog = Ext.extend(Ext.Window, {

	show : function(config){

		this.formPanel.baseParams.task=config.task;
		GO.projects2.RemindDialog.superclass.show.call(this);
	},
	initComponent : function(){

		this.title=GO.projects2.lang.selectPeriod;

		this.width=500;
		this.autoHeight=true;

		this.closeAction='hide';

		var now = new Date();
		var lastMonth = now.add(Date.MONTH, -1);
		var startOfLastMonth = lastMonth.getFirstDateOfMonth();
		var endOfLastMonth = lastMonth.getLastDateOfMonth();	

		this.startDate = new Ext.form.DateField({
			name: 'start_date',
			format: GO.settings['date_format'],
			allowBlank:true,
			fieldLabel: GO.lang.strStart,
			value: startOfLastMonth.format(GO.settings.date_format)
		});

		this.endDate = new Ext.form.DateField({
			name: 'end_date',
			format: GO.settings['date_format'],
			allowBlank:true,
			fieldLabel: GO.lang.strEnd,
			value: endOfLastMonth.format(GO.settings.date_format)
		});
		

		this.items=this.formPanel = new Ext.form.FormPanel({
			url:GO.settings.modules.projects2.url+'json.php',
			baseParams:{
				task:'remind_timeregistration_users'
			},
			bodyStyle:'padding:5px',
			waitMsgTarget:true,
			items:[{
				layout:'table',
				border:false,
				defaults:{
					border:false,
					layout:'form'
				},
				items:[
				{
					items:this.startDate
				},{
					bodyStyle:'padding-left:5px',
					items:new Ext.Button({
						text: GO.projects2.lang.previousMonth,
						handler: function(){
							this.changeMonth(-1);
						},
						scope:this
					})
				}]
			}, {
				layout:'table',
				border:false,
				defaults:{
					border:false,
					layout:'form'
				},
				items:[
				{
					items:this.endDate
				},{
					bodyStyle:'padding-left:5px',
					items:new Ext.Button({
						text: GO.projects2.lang.nextMonth,
						handler: function(){
							this.changeMonth(1);
						},
						scope:this
					})
				}]
			}			
			]
		});

		this.buttons=[
		{
			text:GO.lang.cmdOk,
			handler: this.submitForm,
			scope: this
		},
		{
			text:GO.lang['cmdClose'],
			handler: function(){
				this.hide()
				},
			scope: this
		}];

		GO.projects2.RemindDialog.superclass.initComponent.call(this);
	},
	submitForm : function(){
		this.formPanel.form.submit({
			waitMsg:GO.lang.waitMsgUpload,
			success:function(form, action){
				this.hide();

				GO.email.showComposer({
						values : {to: GO.settings.email, bcc: action.result.addresses}
					});
			},
			failure: function(form, action) {
				if(action.failureType == 'client')
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});
	},
	changeMonth : function(increment)
	{
		var date = this.startDate.getValue();
		date = date.add(Date.MONTH, increment);
		this.startDate.setValue(date.getFirstDateOfMonth().format(GO.settings.date_format));
		this.endDate.setValue(date.getLastDateOfMonth().format(GO.settings.date_format));
	}
});