/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: ResourceGrid.js 18333 2014-02-20 12:28:47Z mschering $
 * @copyright Copyright Intermesh
 * @author Michael de Hart <mdhart@intermesh.nl>
 */

GO.projects2.ResourceGrid = Ext.extend(GO.grid.GridPanel,{
  
	initComponent : function(){
		
		var feeColumns = [	{
			header: GO.lang.strUser,
			dataIndex: 'user_name'
		},{
			header: GO.projects2.lang.externalFee,
			dataIndex: 'external_fee',			
			align:'right'
		},{
			header: GO.projects2.lang.internalFee,
			dataIndex: 'internal_fee',			
			align:'right'
		},{
			header: GO.projects2.lang.budgetedUnits,
			dataIndex: 'budgeted_units'
		//align:'right'
		}];
    
		Ext.apply(this,{
			title:GO.projects2.lang['employees'],
			standardTbar:true,
			paging: true,
			viewConfig: {
				getRowClass : function(row, index) {	
					if (row.data.disabled == '1') {
						return 'go-grid-row-inactive';
					} 
				}
			},
			store: new GO.data.JsonStore({
				url: GO.url("projects2/resource/store"),
				baseParams: {
					project_id:0
				},
				fields: ['project_id', 'user_id','user_name', 'internal_fee', 'external_fee','budgeted_units'],
				remoteSort: false
			}),
			relatedGridParamName: 'project_id',
			editDialogClass: GO.projects2.ResourceDialog,
			border: false,
			listeners:{
				show:function(){
					if(!this.store.loaded)
						this.store.load();
				},
				/*show:function(){
					this.store.load();
				},*/
				scope:this
			},
			cm:new Ext.grid.ColumnModel({
				defaults:{
					sortable:true
				},
				columns:feeColumns
			})
		});
 
		GO.projects2.ResourceGrid.superclass.initComponent.call(this);		
	},
	setProjectId : function(project_id){
		if(this.store.baseParams.project_id!=project_id){
			this.store.baseParams.project_id=project_id;
			this.setDisabled(GO.util.empty(project_id));

			this.store.removeAll();
			this.store.loaded=false;
		}
	},
	/*
    dblClick : function(grid, record, rowIndex){
		if(this.editDialogClass){
			this.showEditDialog(record.data.user_id);
		}
	},*/
	showEditDialog : function(id){
		if(!this.editDialog){
			this.editDialog = new this.editDialogClass;

			this.editDialog.on('save', function(){   
				this.store.reload();   
				this.changed=true;
			}, this);	
		}

//		this.editDialog.formPanel.baseParams['user_id'] = id;
		this.editDialog.formPanel.baseParams['project_id'] = this.store.baseParams.project_id;
		//if(this.relatedGridParamName)
		//this.editDialog.formPanel.baseParams[this.relatedGridParamName]=this.store.baseParams[this.relatedGridParamName];
		
		this.editDialog.show(id,{
			loadParams:{
				project_id:this.store.baseParams.project_id,
				user_id:id
			}
		});	  
	} 

});
