/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: StandardTaskDialog.js 17031 2013-10-13 09:20:34Z mschering $
 * @copyright Copyright Intermesh
 * @author Michael de Hart <mdhart@intermesh.nl>
 */

/**
 * This is the dialog for create and update the Standard tasks / Activities
 * It is also used in the settings dialog of the time registration module
 */
GO.projects2.StandardTaskDialog = Ext.extend(GO.dialog.TabbedFormDialog, {

	initComponent: function() {

		Ext.apply(this, {
			goDialogId: 'pm-standardTask',
			layout: 'fit',
			title: GO.projects2.lang['activityType'],
			width: 500,
			height: 280,
			resizable: false,
			formControllerUrl: 'projects2/standardTask'
		});

		GO.projects2.StandardTaskDialog.superclass.initComponent.call(this);
	},
	buildForm: function() {

		this.formPanel = new Ext.Panel({
			cls: 'go-form-panel',
			layout: 'form',
			labelWidth: 100,
			items: [
			{
				name: 'code',
				xtype: 'textfield',
				fieldLabel: GO.projects2.lang['code'],
				width: 100,
				allowBlank:false
			},{
				name: 'name',
				xtype: 'textfield',
				fieldLabel: GO.lang['strName'],
				anchor: '100%',
				allowBlank:false
			},{
				xtype: 'compositefield',
				fieldLabel: GO.projects2.lang['defaultDuration'],
				items: [
				{
					name: 'units',
					xtype: 'numberfield',
					width: 100,
					allowBlank:false
				},
				{
					xtype:'htmlcomponent',
					html: GO.timeregistration2.lang['hours']
				}
				]
			},{
				name: 'description',
				xtype: 'textarea',
				fieldLabel: GO.lang['strDescription'],
				anchor: '100%',
				allowBlank:true
			},{
				name: 'disabled',
				xtype: 'xcheckbox',
				fieldLabel: GO.lang['disabled']
			}
			]
		});

		this.addPanel(this.formPanel);
	}

});