GO.tickets.InvoiceDialog = Ext.extend(Ext.Window, {

	initComponent : function(){

		this.title=GO.tickets.lang.bill;

		this.width=500;
		this.autoHeight=true;

		this.closeAction='hide';


		var now = new Date();
		var lastMonth = now.add(Date.MONTH, -1);
		var startOfLastMonth = lastMonth.getFirstDateOfMonth();
		var endOfLastMonth = lastMonth.getLastDateOfMonth();

//		this.groupBySelect = new Ext.form.ComboBox({
//			fieldLabel: GO.tickets.lang['groupBy'],
//			name: 'group_by',
//			store:  new Ext.data.SimpleStore({
//					fields: ['id', 'text'],
//					data : [
//						['company',GO.tickets.lang['company']],
//						['customer_account',GO.tickets.lang['customerAccount']]
//					]
//				}),
//			displayField:'text',
//			valueField: 'id',
//			hiddenName:'group_by',
//			mode:'local',
//			triggerAction:'all',
//			editable: false,
//			selectOnFocus:true,
//			forceSelection: true,
//			value: 'company',
//			anchor: '100%'
//		});

		this.startDate = new Ext.form.DateField({
			name: 'start_date',
			format: GO.settings['date_format'],
			allowBlank:false,
			value: startOfLastMonth.format(GO.settings.date_format)
		});

		this.endDate = new Ext.form.DateField({
			name: 'end_date',
			format: GO.settings['date_format'],
			allowBlank:false,
			value: endOfLastMonth.format(GO.settings.date_format)
		});

		this.selectBook = new GO.form.ComboBox({
			fieldLabel: GO.billing.lang.bookId,
			hiddenName:'book_id',
			anchor:'100%',
			emptyText:GO.lang.strPleaseSelect,
			store: new GO.data.JsonStore({
				url: GO.settings.modules.billing.url+ 'json.php',
				baseParams: {
					task: 'books',
					auth_type: 'write'
				},
				root: 'results',
				id: 'id',
				totalProperty:'total',
				fields: ['id','name', 'user_name', 'report_checked'],
				remoteSort: true
			}),
			pageSize: parseInt(GO.settings.max_rows_list),
			valueField:'id',
			displayField:'name',
			mode: 'remote',
			triggerAction: 'all',
			editable: true,
			selectOnFocus:true,
			forceSelection: true,
			allowBlank: false
		});



		this.items=this.formPanel = new Ext.form.FormPanel({
			url:GO.url('tickets/ticket/invoice'),
			baseParams:{
			},
			bodyStyle:'padding:5px',
			waitMsgTarget:true,
			items:[
			//this.groupBySelect,
			this.fromStatus = new GO.tickets.SelectStatus({
				fieldLabel:GO.tickets.lang.fromStatus,
				anchor:'100%',
				emptyText:GO.lang.strPleaseSelect,
				hiddenName:'from_status_id',
				allowBlank:false
			}),
			this.toStatus = new GO.tickets.SelectStatus({
				fieldLabel:GO.tickets.lang.toStatus,
				anchor:'100%',
				emptyText:GO.lang.strPleaseSelect,
				hiddenName:'to_status_id',
				allowBlank:false
			}),
			this.toStatus = new GO.tickets.SelectStatus({
				fieldLabel:GO.tickets.lang.invoiceErrorStatus,
				anchor:'100%',
				emptyText:GO.lang.strPleaseSelect,
				hiddenName:'error_status_id',
				allowBlank:false
			}),
			this.selectBook,
			{
				xtype:'compositefield',
				fieldLabel: GO.lang.strStart,
				items:[
				this.startDate,
				new Ext.Button({
						text: GO.lang.cmdPrevious,
						width:100,
						handler: function(){
							this.changeMonth(-1);
						},
						scope:this
					})]
			}, {
				xtype:'compositefield',
				fieldLabel: GO.lang.strEnd,
				items:[
					this.endDate,
					new Ext.Button({
						text: GO.lang.cmdNext,
						width:100,
						handler: function(){
							this.changeMonth(1);
						},
						scope:this
					})]
			},{
				xtype:'checkbox',
				name:'change_tickets_without_hours_too',
				checked:true,
				hideLabel:true,
				boxLabel:GO.tickets.lang.changeTicketsWithoutHoursToo
			},{
				xtype:'textarea',
				fieldLabel:'Template',
				name:'template',
				anchor:'100%',
				value:GO.tickets.bill_item_template
			}
			]
		});

		this.buttons=[
		{
			text:GO.lang.cmdOk,
			handler: this.submitForm,
			scope: this
		},
		{
			text:GO.lang['cmdClose'],
			handler: function(){
				this.hide()
				},
			scope: this
		}];

		this.addEvents({
			'invoice': true
		});

		GO.tickets.InvoiceDialog.superclass.initComponent.call(this);
	},
	submitForm : function(){
		this.formPanel.form.submit({
			waitMsg:GO.lang.waitMsgUpload,
			success:function(form, action){
				
				Ext.MessageBox.alert(GO.lang.strSuccess, action.result.feedback);
//				//if(GO.util.empty())
//				//this.hide();
//
//				var response = Ext.decode(action.response.responseText);
//				var ticket_ids = Ext.decode(response.no_address_ticket_ids);
//
//				if (typeof(ticket_ids)=='object' && ticket_ids.length>0) {
//					Ext.MessageBox.show({
//						title: GO.tickets.lang.printQuestion,
//						msg: GO.tickets.lang.noAddressTickets,
//						buttons: Ext.Msg.YESNO,
//						fn: function(btn) {
//							if (btn=='yes') {
//								Ext.Ajax.request({
//									url : GO.settings.modules.tickets.url + 'action.php',
//									params : {
//										'task' : 'save_tickets_without_addresses',
//										'ticket_ids' : Ext.encode(ticket_ids)
//									},
//									success: function(response, opts) {
//											var obj = Ext.decode(response.responseText);
//											Ext.MessageBox.alert(GO.lang.strSuccess,GO.tickets.lang.ticketReportSaved);
//									 },
//									 failure: function(response, opts) {
//											Ext.MessageBox.alert(GO.lang.strError,'server-side failure with status code ' + response.status);
//									 },
//									scope : this
//								})
//							}
//						},
//						animEl: 'elId',
//						icon: Ext.MessageBox.QUESTION
//					});
//				} else {
//					Ext.MessageBox.alert(GO.lang.strSuccess, action.result.feedback);
//				}

				this.fireEvent('invoice');
			},
			failure: function(form, action) {
				if(action.failureType == 'client')
				{
					Ext.MessageBox.alert(GO.lang['strError'], GO.lang['strErrorsInForm']);
				} else {
					Ext.MessageBox.alert(GO.lang['strError'], action.result.feedback);
				}
			},
			scope: this
		});
	},
	changeMonth : function(increment)
	{
		var date = this.startDate.getValue();
		date = date.add(Date.MONTH, increment);
		this.startDate.setValue(date.getFirstDateOfMonth().format(GO.settings.date_format));
		this.endDate.setValue(date.getLastDateOfMonth().format(GO.settings.date_format));
	},
	show:function(config){
		config = config || {};

		GO.tickets.InvoiceDialog.superclass.show.call(this);
	}
});

