/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @copyright Copyright Intermesh
 * @author WilmarVB <wilmar@intermesh.nl>
 */
GO.timeregistration.GloballySetStatusesGrid = function(config){

	if(!config)
	{
		config = {};
	}

	config.title = GO.timeregistration.lang.statuses;
	config.layout='fit';
	config.autoScroll=true;
	config.split=true;
	config.paging=true,
	config.height=340,
	config.store = new GO.data.JsonStore({
		url: GO.settings.modules.timeregistration.url+ 'json.php',
		baseParams: {
			task: 'global_statuses'
		},
		id: 'id',
		root: 'results',
		fields: ['id','name','checked'],
		remoteSort: true
	});

	var checkColumn = new GO.grid.CheckColumn({
		header: '&nbsp;',
		dataIndex: 'checked',
		width: 30
	});

	config.plugins = [checkColumn];

	var statusesColumnModel = new Ext.grid.ColumnModel(
		[
			checkColumn,
			{
				header: GO.lang.strName, 
				dataIndex: 'name',
				id:'name'
			}]);

	statusesColumnModel.defaultSortable= true;
	config.cm=statusesColumnModel;
	config.autoExpandColumn='name';

	config.view=new Ext.grid.GridView({
		emptyText: GO.lang['strNoItems']
	});

	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;

	/*
	 * explicitly call the superclass constructor
	 */
	GO.timeregistration.GloballySetStatusesGrid.superclass.constructor.call(this, config);

};
/*
 * Extend the base class
 */
Ext.extend(GO.timeregistration.GloballySetStatusesGrid, GO.grid.GridPanel,{

	afterRender : function()
	{
		GO.timeregistration.GloballySetStatusesGrid.superclass.afterRender.call(this);
		this.store.load();
	}
	
});

