/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @copyright Copyright Intermesh
 * @author WilmarVB <wilmar@intermesh.nl>
 */
GO.timeregistration.GloballySetStatusesPanel = function(config){

	if(!config)
	{
		config = {};
	}

	config.title = GO.timeregistration.lang.globalStatusFilters;
	config.layout='border';
	config.autoScroll=true;
	config.split=true;
	config.paging=true,
	config.width='100%';
	config.height=340,
	config.border= false;
	config.cls = 'go-form-panel';

	this.buildForm();

	config.items = [
		this.northPanel,
		this.globallySetStatusFiltersGrid
//		,
//		this.southPanel
	];

	/*
	 * explicitly call the superclass constructor
	 */
	GO.timeregistration.GloballySetStatusesPanel.superclass.constructor.call(this, config);

};
/*
 * Extend the base class
 */
Ext.extend(GO.timeregistration.GloballySetStatusesPanel, Ext.form.FormPanel,{
	
	buildForm : function() {
		
		this.northPanel = new Ext.Panel({
			region : 'north',
			height: 120,
			border: false,
			items : [
				{
					xtype: 'plainfield',
					height: 40,
					hideLabel : true,
					value: '<br />'+GO.timeregistration.lang['globallySetStatusFiltersHere']+'<br /><br />'
				},
				this.closeFiltersByDefaultCheckbox = new Ext.form.Checkbox({
					boxLabel: GO.timeregistration.lang.defaultCloseFilters,
					labelSeparator: '',
					name: 'default_close_filters',
					allowBlank: true
//					,
//					ctCls:'pm-show-mine-only-cb'
				}),
				this.showMineOnlyCheckbox = new Ext.form.Checkbox({
					boxLabel: GO.timeregistration.lang.onlyShowOwn,
					labelSeparator: '',
					name: 'only_show_own',
					allowBlank: true,
					ctCls:'pm-show-mine-only-cb',
					disabled: true
				})
			]
		})
				
		this.globallySetStatusFiltersGrid = new GO.timeregistration.GloballySetStatusesGrid({'region':'center',disabled: true,border:false});

		this.closeFiltersByDefaultCheckbox.on('check',function(checkbox,checked){
			this.showMineOnlyCheckbox.setDisabled(!checked);
			this.globallySetStatusFiltersGrid.setDisabled(!checked);
		},this);		
		
		this.globallySetStatusFiltersGrid.store.on('load',function(store,records,options){
			this.showMineOnlyCheckbox.setValue(store.reader.jsonData['show_mine_only']);
			this.closeFiltersByDefaultCheckbox.setValue(store.reader.jsonData['disable_filter_panel']);
		},this);
		
//		this.southPanel = new Ext.Panel({
//			region: 'south',
//			height: 40,
//			items: [this.globallyApplyButton = new Ext.Button({
////				iconCls:'btn-download',
//				text:GO.timeregistration.lang.applyForAll,
//				handler: function(){
//					this.globallyApplyFilterSettings()
//				},
//				scope:this,
//				disabled:false
//			})]
//		})
	},
	
	_getCheckedFilterIds : function() {
		var checkedFilterIds = [];
		var gridData = this.globallySetStatusFiltersGrid.getGridData();
		for (var i=0; i<gridData.length; i++) {
			if ( gridData[i].checked )
				checkedFilterIds.push(gridData[i].id);
		}
		return checkedFilterIds;
	},
	
	_getFormValuesAsParams : function() {
		return {
			'default_close_filters' : this.closeFiltersByDefaultCheckbox.getValue(),
			'only_show_own' : this.showMineOnlyCheckbox.getValue(),
			'filters' : Ext.encode(this._getCheckedFilterIds())
		};
	},
	
	globallyApplyFilterSettings : function() {
		
		var settings = this._getFormValuesAsParams();
		
//		Ext.Msg.show({
//			title: GO.timeregistration.lang['globalSetSure'],
//			msg: GO.timeregistration.lang['globalSetSureMsg'],
//			buttons: Ext.Msg.YESNO,
//			scope:this,
//			fn: function(btn) {
//				if (btn=='yes') {
					Ext.Ajax.request({
						url : GO.settings.modules.timeregistration.url + 'action.php',
						params : {
							task : 'globally_apply_filter_settings',
							default_close_filters : settings['default_close_filters'],
							only_show_own : settings['only_show_own'],
							filters : settings['filters']
						},
						scope : this,
						callback : function(options, success, response) {
							var data = Ext.decode(response.responseText);
							if (!data.success) {
								Ext.Msg.alert(GO.lang['strError'],data.feedback);
							} else {
								if (data.feedback) {
									Ext.Msg.alert(GO.lang['strNotice'],data.feedback);
								}
//								else {
//									Ext.Msg.alert(GO.lang['strSuccess'],GO.timeregistration.lang['globalFilterSetSuccess'])
//								}
							}
						}
					});
//				}
//			}
//		});
	}
	
});

