/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @copyright Copyright Intermesh
 * @version $Id: HoursDialog.js 15897 2013-05-21 09:02:45Z mschering $
 * @author Merijn Schering <mschering@intermesh.nl>
 */


GO.timeregistration.HoursDialog = Ext.extend(GO.dialog.TabbedFormDialog , {
	initComponent : function(){
		
		Ext.apply(this, {
			//			titleField:'name',
			loadOnNewModel:false,
			goDialogId:'hoursdialog',
			stateId:'tr-hoursdialog',
			title:GO.projects.lang.units,
			height: 230,
			width:400,
			
			formControllerUrl: 'projects/hour'
		});
		
		GO.timeregistration.HoursDialog.superclass.initComponent.call(this);	
	},
	
	buildForm : function(){
		
		this.selectUser = new GO.form.SelectUser({
			fieldLabel:GO.lang.strUser
		});
		
		
		this.projectField = new Ext.form.Hidden({
			name:'project_id'
			
		});
		
		this.unitsField = new GO.form.NumberField({
			name: 'units',
			width: 40,
			allowBlank:false,
			fieldLabel: GO.projects.lang.units,
			value: GO.util.numberFormat("0",2,GO.settings.decimal_separator, GO.settings.thousands_separator)
		});  	      		

		var comments = new Ext.form.TextArea({
			name: 'comments',
			anchor:'100%',			
			height:100,
			allowBlank:true,
			fieldLabel: GO.lang.strDescription
		});
  	
		var now = new Date();
		var date = new Ext.form.DateField({
			name: 'date',
			anchor:'100%',
			format: GO.settings['date_format'],
			allowBlank:false,
			fieldLabel: GO.lang['strDate'],
			value: now.format(GO.settings.date_format)
		});
  	
			this.selectFee = new GO.timeregistration.SelectFee({
				anchor:'100%'
			
			});
	
		var items =[
			this.projectField,
			this.unitsField,
			date,
			this.selectFee,
			comments,
			this.selectUser			
		] ;

		if(GO.customfields){
			var cfFS, formField;
			for(var i=0;i<GO.customfields.types["GO_Projects_Model_Hour"].panels.length;i++)
			{
				var cfPanel = GO.customfields.types["GO_Projects_Model_Hour"].panels[i];

				cfFS = {
					layout: 'form',
					columnWidth:.5,
					border:false,
					items:[]
				};
				for(var n=0;n<cfPanel.customfields.length;n++)
				{
					formField = GO.customfields.getFormField(cfPanel.customfields[n]);
					formField.anchor='100%';
					cfFS.items.push(formField);
				}
				items.push(cfFS);
			}
		}
		
		this.addPanel({
			autoScroll:true,
			layout:'form',
			bodyStyle:'padding:5px',
			items:items
		});
		
	}
});
