GO.timeregistration.HoursGrid = function(config){
	
	if(!config)
	{
		config = {};
	}

	var summary = new Ext.grid.GroupSummary();
	config.plugins=[summary];


	var fields ={
		fields:['id','units', 'date', 'fee_name', 'comments', 'project_name','day'],
		columns:[
		{
			header:GO.projects.lang.units,
			dataIndex: 'units',
			width:60,
			align:'right',
			summaryType:'sum'
		},
		{
			header:GO.projects.lang.project,
			dataIndex: 'project_name',
			id:'project',
			renderer:function(v, meta, r){
				return v+'<p class="pm-hours-comments" style="padding-left:0px;">'+r.data.comments+'</p>';
			}
		},
		{
			header:GO.projects.lang.fee,
			dataIndex: 'fee_name',
			width:100
		},
		{
			header:GO.lang.strDay,
			dataIndex: 'day'
		}
		]
	};

	if(GO.customfields)
	{
		GO.customfields.addColumns(19, fields);
	}


	var reader = new Ext.data.JsonReader({
		root: 'results',
		totalProperty: 'total',
		id: 'id',
		fields:fields.fields
	});

	config.store = new Ext.data.GroupingStore({
		url : GO.settings.modules.timeregistration.url + 'json.php',
		baseParams : {
			task : 'hours'
		},
		sortInfo:{
			field: 'date',
			direction: "ASC"
		},
		id : 'id',
		reader:reader,
		groupField:'day',
		remoteSort:true,
		remoteGroup:true
	});
	

	if(config.project_id)
	{
		this.setProjectId(config.project_id);
	}
	
		
	config.columns=fields.columns;


	config.view = new Ext.grid.GroupingView({
		showGroupName: false,
		enableNoGroups:false, // REQUIRED!
		hideGroupedColumn: true,
		emptyText : GO.lang['strNoItems'],		
		emptyText: GO.timeregistration.lang.noHours
	});

	config.autoExpandMax=2500;
	config.autoExpandColumn='project';

	config.sm=new Ext.grid.RowSelectionModel();
	config.loadMask=true;
	
	config.tbar=[{
		//iconCls: 'btn-delete',
		text: GO.lang['cmdDelete'],

		handler: function(){
			this.deleteSelected();
		},
		scope: this
	}];

	
	GO.timeregistration.HoursGrid.superclass.constructor.call(this, config);
	
};


Ext.extend(GO.timeregistration.HoursGrid, GO.grid.GridPanel, {
	
	project_id : 0,
	loaded_project_id : 0,
	
	afterRender : function()
	{
		GO.timeregistration.HoursGrid.superclass.afterRender.call(this);
		
		this.on("rowdblclick", function(grid, rowClicked, e){
			if(!this.hoursDialog)
			{
				this.hoursDialog = new GO.timeregistration.HoursDialog();
				this.hoursDialog.on('save', function(){
					this.store.reload();
				}, this);
			}
			this.hoursDialog.show(grid.selModel.selections.keys[0]);
		}, this);
	},	
	onShow : function(){		
		GO.timeregistration.HoursGrid.superclass.onShow.call(this);
		
		if(this.loaded_project_id!=this.project_id)
		{
			this.loaded_project_id=this.project_id;
			this.store.load();
		}		
	},
	
	setProjectId : function(project_id)
	{
		this.project_id=project_id;
		this.store.baseParams.project_id=project_id;
	} 
});
