
GO.timeregistration.CommentsPanel = function(config) {
	config = config || {};

	config.layout = 'form';
	config.items = this.commentsField = new Ext.form.TextArea({
		hideLabel : true,
		anchor : '100% 100%'
	});
	config.title = GO.lang.strDescription;

	GO.timeregistration.CommentsPanel.superclass.constructor.call(this, config);

	this.commentsField.on('blur', function() {
		this.record.set(this.name, this.commentsField.getValue());
	}, this);

}

Ext.extend(GO.timeregistration.CommentsPanel, Ext.Panel, {

	name : '',
	record : false,

	setField : function(name, record) {
		this.name = name;
		this.record = record;
		this.commentsField.setValue(record.get(this.name));
		this.commentsField.setDisabled(false);
	}
});

GO.timeregistration.MainPanel = function(config){

	if(!config)
	{
		config = {};
	}

	config.layout='border';
	config.border=false;

	
	this.navPanel = new GO.projects.NavigationPanel({
		title:GO.lang.strWeek,
		url:GO.settings.modules.timeregistration.url + 'json.php',
		region:'center',
		split:true
	});

	this.navPanel.getSelectionModel().on('beforerowselect', function(){
		return this.timeSheet.confirmChanges();
	}, this);
	this.navPanel.getSelectionModel().on('rowselect', function(sm, i, record){

		var closed = record.get('closed');
		
		this.setClosed(closed);
		return this.timeSheet.setDate(Date.parseDate(record.get('value'), GO.settings.date_format));
	}, this);


	var westPanelItems=[];

	
	var items = [];
	
	this.filterPanel = new GO.projects.StatusFilterPanel({
		region:'south',
		height:200,
		hidden: true,
		store:new GO.data.JsonStore({
			url: GO.settings.modules.timeregistration.url+ 'json.php',
			baseParams: {
				task: 'statuses'
			},
			root: 'results',
			id: 'id',
			totalProperty:'total',
			fields: ['id','name','checked'],
			remoteSort: true
		})
	});
	this.filterPanel.on('change', function(grid, statuses, showMineOnly){
		var store;
		if(GO.timeregistration.mode=='grid'){
			store =this.timeSheet.store;
		}else
		{
			store=this.timeSheet.selectProject.store;
		}

		store.baseParams.statuses = Ext.encode(statuses);
		store.baseParams.showMineOnly = showMineOnly;
		store.load();
		delete store.baseParams.showMineOnly;
		delete store.baseParams.statuses;
	}, this);

	westPanelItems=[this.navPanel,this.filterPanel];

	if(GO.timeregistration.mode=='grid'){		

		this.commentsPanel = new GO.timeregistration.CommentsPanel({
			title:GO.lang.strDescription,
			region:'south',
			collapsible:true,
			height:100,
			split:true
		});

		this.timeSheet = new GO.timeregistration.TimeSheet({
			region:'center',
			commentsPanel: this.commentsPanel,
			id:'tr-timesheet'
		});

		this.searchField = new GO.form.SearchField({
			store: this.timeSheet.store,
			emptyText: GO.lang.strSearch,
			width:200
		});

		items=[this.timeSheet,this.commentsPanel];
	}else
	{
		this.timeSheet = new GO.timeregistration.MultiplePerDay({
			region:'center'
		});
		items=[this.timeSheet];
	}

	var westPanel = new Ext.Panel({
		id:'tr-west',
		region:'west',
		layout:'border',
		border:false,
		split:true,
		width:200,
		items:westPanelItems,
		collapsible:true,
		collapseMode:'mini',
		header:false
	});


	this.filterPanel.store.on('load', function(store,records,options){
		if (!GO.util.empty(store.reader.jsonData['disable_filter_panel']))
			this.filterPanel.hide();
		else
			this.filterPanel.show();
		this.doLayout();
	},this);


	this.centerPanel = new Ext.Panel({
		region:'center',
		border:false,
		layout:'border',
		items:items
	});

	config.items=[this.centerPanel,westPanel];


	var tbarItems = [{
		xtype:'htmlcomponent',
		html:GO.timeregistration.lang.name,
		cls:'go-module-title-tbar'
	}];

	if(GO.timeregistration.mode=='grid'){
		tbarItems.push(this.saveButton = new Ext.Button({
			text : GO.lang.cmdSave,
			iconCls:'btn-save',
			handler : function(){
				this.save();
			},
			scope : this
		}),
		'-');
	}

	tbarItems.push(this.closeWeekButton = new Ext.Button({
		iconCls:'btn-close',
		text : GO.projects.lang.closeWeek,
		handler : function() {
			if (!this.timeSheet.timer_running) {
				this.closeWeek();
			} else {
				alert(GO.projects.lang.timerRunning);
			}
		},
		scope : this
	}),{
		iconCls: 'btn-refresh',
		text: GO.lang['cmdRefresh'],
		cls: 'x-btn-text-icon',
		handler: function(){
			this.refresh();
		},
		scope: this
	});

	tbarItems.push(this.printButton = new Ext.Button({
		iconCls: 'btn-print',
		text: GO.lang.cmdPrint,
		cls: 'x-btn-text-icon',
		handler: function(){
			//console.log(GO.settings.modules.timeregistration.url+'print_report.php?date='+this.timeSheet.store.baseParams.date+'&user_id='+this.timeSheet.store.baseParams.user_id);
			window.open(GO.settings.modules.timeregistration.url+'print_report.php?date='+this.timeSheet.store.baseParams.date+'&user_id='+this.timeSheet.store.baseParams.user_id);
		},
		scope: this
	}));

	if(GO.timeregistration.mode!='grid'){
		this.toggleWindowButton = new Ext.Button({
			iconCls:'btn-toggle-window',
			text: GO.timeregistration.lang.toggleWindowPosition,
			cls: 'x-btn-text-icon',
			handler: function(){
				this.timeSheet.moveGrid();
			},
			scope: this
		});

		tbarItems.push('-',this.toggleWindowButton);
	}


	if (GO.settings.modules.timeregistration.write_permission) {

		tbarItems.push('-',{
			iconCls:'btn-settings',
			text:GO.lang.administration,
			handler:function(){
				if(!this.settingsDialog)
				{
					this.settingsDialog = new GO.timeregistration.SettingsDialog();
				}
				this.settingsDialog.show();
			},
			scope:this
		},'-',this.selectUser = new GO.form.SelectUser({
			width:200,
			listeners:{
				select:function(cb, r){
					this.timeSheet.store.baseParams.user_id=r.id;
					this.navPanel.store.baseParams.user_id=r.id;
					this.navPanel.store.load();
					
					this.timeSheet.store.load();
					
				},
				scope:this
			}
		}));
	}

	if(this.searchField){
		tbarItems.push('-');
		tbarItems.push(this.searchField);
	}

	tbarItems.push(GO.timeregistration.timerButton = new GO.timeregistration.TimerButton({
		startTime: GO.timeregistration.timerStartTime,
		listeners:{
			scope:this,
			beforestoptimer:function(){
				if(GO.timeregistration.mode=='grid'){
					alert(GO.timeregistration.lang.clickAtTimerBtn);
					return false;
				}else
				{
					return true;
				}
			},
			stoptimer:function(btn, elapsed, startTime){
				if(GO.timeregistration.mode!='grid'){
					this.timeSheet.unitsField.setValue(GO.util.numberFormat(elapsed));
				}else
				{
					var c = this.timeSheet.getColumnModel();
					var i = c.getIndexById('timer');
					c.setHidden(i, true);
				}
			},
			starttimer:function(){
				if(GO.timeregistration.mode=='grid'){
					var c = this.timeSheet.getColumnModel();
					var i = c.getIndexById('timer');
					c.setHidden(i, false);
				}
			}
		}
	}));	

	tbarItems.push(this.copyWeekButton = new Ext.Button({
			iconCls:'btn-actions',
			text:GO.timeregistration.lang.copyLastWeek,
			handler:function(){
				Ext.Msg.confirm(GO.timeregistration.lang.copyLastWeek, GO.timeregistration.lang.copyLastWeekConfirm, function(btn, text){
					if (btn.toLowerCase() == 'yes') {
						Ext.Ajax.request({
							url : GO.settings.modules.timeregistration.url + 'action.php',
							params : {
								task : 'copy_week',
								user_id : this.timeSheet.store.baseParams.user_id,
								date : this.timeSheet.store.baseParams.date,
								type: this.timeSheet.store.baseParams.task
								//,overwrite : overwrite
							},
							scope : this,
							callback : function(options, success, response) {
								var data = Ext.decode(response.responseText);
								if (!data.success) {
									Ext.Msg.alert(GO.lang['strError'],data.feedback);
								} else {
									this.timeSheet.store.load();
									if (data.feedback) {
										Ext.Msg.alert(GO.lang['strNotice'],data.feedback);
									}
								}
							}
						});
					}
				},
				this);
			},
			scope:this
		})
	);

	config.tbar= new Ext.Toolbar({
		cls:'go-head-tb',
		items:tbarItems
	});
	

	GO.timeregistration.MainPanel.superclass.constructor.call(this, config);
};


Ext.extend(GO.timeregistration.MainPanel, Ext.Panel, {

	setClosed : function(closed) {
		if(GO.settings.modules.projects.write_permission){

			if(!closed){
				this.closeWeekButton.setText(GO.projects.lang.closeWeek);
				this.closeWeekButton.handler=this.closeWeek;
			}else
			{
				this.closeWeekButton.setText(GO.projects.lang.openWeek);
				this.closeWeekButton.handler=this.openWeek;
			}

		}else
		{
			this.closeWeekButton.setDisabled(closed);
		}
		if(this.saveButton)
			this.saveButton.setDisabled(closed);
		if(this.copyWeekButton)
			this.copyWeekButton.setDisabled(closed);
		
		this.centerPanel.setDisabled(closed);
	},

	save : function(cb) {

		/*var ts = this.timeSheet;

		ts.el.mask(GO.lang.waitMsgSave);

		Ext.Ajax.request({
			url : GO.settings.modules.timeregistration.url + 'action.php',
			params : {
				task : 'timesheet',
				timesheet : Ext.encode(ts.getGridData()),
				user_id : ts.store.baseParams.user_id,
				date : ts.store.baseParams.date
			},
			callback : function(options, success, response) {
				var responseParams = Ext
				.decode(response.responseText);
				if (!responseParams.success) {
					alert(responseParams.feedback);
				} else {
					ts.store.commitChanges();

					ts.updateTotals(true);

					//ts.store.reload();

					if(cb){
						cb.call(this);
					}
				}
				ts.el.unmask();
			},
			scope : this
		});*/
		this.timeSheet.save({
			callback:cb,
			scope:this
		});
	},

	refresh : function(){
		//GO.timeregistration.statusesStore.load();
		//this.timeregistrationView.timeregistrationPanel.store.load();
		//this.treePanel.rootNode.reload();
		//console.log('ja');
		if(this.filterPanel)
			this.filterPanel.store.load();
		
		this.navPanel.store.load({
			callback:function(){
				this.navPanel.selectNow();
			},
			scope:this
		});
		GO.timeregistration.stores.readableFees.load();
	},
	closeWeek : function() {

		if(this.timeSheet.isDirty()){
			this.save(this.closeWeek);
		}else
		{
			if (confirm(GO.projects.lang.confirmBookedHours.replace(
				'{HOURS}', this.timeSheet.hours_booked))) {
				//this.timeSheet.store.commitChanges();

				Ext.Ajax.request({
					url : GO.settings.modules.timeregistration.url
					+ 'action.php',
					params : {
						task : 'close_week',
						user_id : this.timeSheet.store.baseParams.user_id,
						date : this.timeSheet.store.baseParams.date
					},
					scope : this,
					callback : function(options, success,
						response) {
						var data = Ext
						.decode(response.responseText);

						if (!data.success) {
							Ext.Msg.alert(GO.lang['strError'],
								data.feedback)
						} else {
							//this.timeSheet.store.load();

							var i = this.navPanel.store.findBy(function(r){
								return r.get('value')==this.timeSheet.store.baseParams.date;
							}, this);

							this.setClosed(true);

							if(i>-1){
								var r = this.navPanel.store.getAt(i);
								r.set('closed', 1);
							}
						}
					}
				});
			}
		}
	},
	openWeek : function() {
		Ext.Ajax.request({
			url : GO.settings.modules.timeregistration.url
			+ 'action.php',
			params : {
				task : 'open_week',
				user_id : this.timeSheet.store.baseParams.user_id,
				date : this.timeSheet.store.baseParams.date
			},
			scope : this,
			callback : function(options, success, response) {
				var data = Ext.decode(response.responseText);

				if (!data.success) {
					Ext.Msg.alert(GO.lang['strError'],
						data.feedback)
				} else {
					this.setClosed(false);
					var i = this.navPanel.store.findBy(function(r){
						return r.get('value')==this.timeSheet.store.baseParams.date;
					}, this);

					if(i>-1){
						var r = this.navPanel.store.getAt(i);
						r.set('closed', 0);
					}
				}
			}
		});

	},
	onShow : function(){
		//this.refresh();
		GO.timeregistration.MainPanel.superclass.onShow.call(this);
	},
	afterRender : function(){

		//GO.timeregistration.stores.readableFees.load();
		this.refresh();
		GO.timeregistration.MainPanel.superclass.afterRender.call(this);
	}

});



/*
 * This will add the module to the main tabpanel filled with all the modules
 */

GO.moduleManager.addModule('timeregistration', GO.timeregistration.MainPanel, {
	title : GO.projects.lang.timeTracking,
	iconCls : 'go-tab-icon-timeregistration'
});

