/** 
 * Copyright Intermesh
 * 
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 * 
 * If you have questions write an e-mail to info@intermesh.nl
 * 
 * @copyright Copyright Intermesh
 * @version $Id: SelectProject.js 15897 2013-05-21 09:02:45Z mschering $
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.timeregistration.SelectProject = function(config){
	
	Ext.apply(this, config);
	
	if(!this.company_name)
	{
		this.company_name = '';
	}
	
	this.store = new GO.data.JsonStore({
		url: GO.settings.modules.timeregistration.url+ 'json.php',
		baseParams:{
				task:'projects'
			},
		root: 'results',
		totalProperty: 'total',
		id: 'id',
		fields:['id', 'path', 'path_with_customer']
	});

	GO.timeregistration.SelectProject.superclass.constructor.call(this,{
		displayField: 'path_with_customer',
		hiddenName:'project_id',		
		valueField: 'id',
		triggerAction:'all',		
		mode:'remote',
		editable: true,
		selectOnFocus:true,
	  forceSelection: true,
		typeAhead: true,
		pageSize: parseInt(GO.settings['max_rows_list']),
		fieldLabel: GO.projects.lang.project
	});
	
}
Ext.extend(GO.timeregistration.SelectProject, GO.form.ComboBox,{
	
});