/**
 * Copyright Intermesh
 *
 * This file is part of Group-Office. You should have received a copy of the
 * Group-Office license along with Group-Office. See the file /LICENSE.TXT
 *
 * If you have questions write an e-mail to info@intermesh.nl
 *
 * @version $Id: SelectType.js 15897 2013-05-21 09:02:45Z mschering $
 * @copyright Copyright Intermesh
 * @author Merijn Schering <mschering@intermesh.nl>
 */

GO.timeregistration.SelectType = Ext.extend(GO.form.ComboBox, {
			initComponent : function(){
				Ext.apply(this, {
					fieldLabel: GO.projects.lang.type,
					hiddenName:'type_id',
					store:GO.timeregistration.typesStore,
					valueField:'id',
					displayField:'name',
					mode: 'local',
					triggerAction: 'all',
					editable: false,
					selectOnFocus:true,
					forceSelection: true,
					allowBlank:false,
					disabled:!GO.settings.modules.timeregistration.write_permission
				});
				
				Ext.form.TwinTriggerField.prototype.initComponent.call(this);
			},
			getTrigger : Ext.form.TwinTriggerField.prototype.getTrigger,
			initTrigger : Ext.form.TwinTriggerField.prototype.initTrigger,
			trigger1Class : 'x-form-edit-trigger',
			//hideTrigger1 : true,
			onViewClick : Ext.form.ComboBox.prototype.onViewClick.createSequence(function() {
				//this.triggers[0].setDisplayed(true);
			}),
			onTrigger2Click : function() {
				this.onTriggerClick();
			},
			onTrigger1Click : function() {

				var v = this.getValue();

		

				if(!GO.timeregistration.typeDialog){
					GO.timeregistration.typeDialog = new GO.timeregistration.TypeDialog();
					GO.timeregistration.typeDialog.on('save', function(){
							GO.timeregistration.typesStore.reload();
						}, this);
				}

				GO.timeregistration.typeDialog.show(v);

			},
			setValue : function(v){
				GO.form.ComboBoxReset.superclass.setValue.call(this, v);
				if(this.rendered)
				{
					//this.triggers[0].setDisplayed(v!='');
				}
			},
			afterRender:function(){
				GO.form.ComboBoxReset.superclass.afterRender.call(this);
				if(Ext.isIE8)this.el.setTop(1);

				//this.on('resize', function(combo, adjWidth, adjHeight, rawWidth, rawHeight ){console.log(adjWidth);}, this);
			}
		});

