GO.timeregistration.TimerButton = function(config){
	config = config || {};

	Ext.apply(config, {
		enableToggle:true,
		pressed:config.startTime>0,
		text:GO.timeregistration.lang.startTimer,
		toggleHandler:function(btn, pressed){
			if(!pressed){
				if(this.fireEvent('beforestoptimer', this)){
					this.stopTimer();
				}
			}else{
				this.startTimer();
			}
		},
		scope:this

	});

	

	GO.timeregistration.TimerButton.superclass.constructor.call(this, config);

	
	if(config.startTime){
		this.setRunning(config.startTime);
	}

	this.addEvents({
		stoptimer : true,
		beforestoptimer : true,
		starttimer : true
	});
}

Ext.extend(GO.timeregistration.TimerButton, Ext.Button,{
	startTime: false,
	setRunning : function(time){
		this.startTime = Date.parseDate(parseInt(time), 'U');
		this.setText(GO.timeregistration.lang.timerRunningSince+': '+this.startTime.format(GO.settings.time_format));
		this.fireEvent('starttimer', this, this.startTime);
		this.toggle(true);
	},
  
	afterRender : function(){
	  Ext.Ajax.request({
			url : GO.settings.modules.timeregistration.url+ 'action.php',
			params : { task : 'read_timer' },
			callback : function(options, success, response) {
				var data = Ext.decode(response.responseText);
				if(data.time!=0){
				  this.startTime = Date.parseDate(parseInt(data.time), 'U');
				  this.setText(GO.timeregistration.lang.timerRunningSince+': '+this.startTime.format(GO.settings.time_format));
				  this.toggle(true,true);
				}
			},
			scope:this
		});
		GO.timeregistration.TimerButton.superclass.afterRender.call(this);
	},

	stopTimer : function(){
		
		var elapsed = GO.util.round(this.startTime.getElapsed()/60000,GO.timeregistration.roundMinutes, !GO.timeregistration.roundUp)/60;
		var startTime = this.startTime;
		
		this.fireEvent('stoptimer', this, elapsed, startTime);

		this.setText(GO.timeregistration.lang.startTimer);

		this.startTime=false;

		this.toggle(false, true);

		Ext.Ajax.request({
			url : GO.settings.modules.timeregistration.url+ 'action.php',
			params : {
				task : 'stop_timer'
			},
			scope:this
		});

		return elapsed;
		
	},

	startTimer : function(){
		Ext.Ajax.request({
			url : GO.settings.modules.timeregistration.url+ 'action.php',
			params : {
				task : 'start_timer'
			},
			callback : function(options, success, response) {
				var data = Ext.decode(response.responseText);

				this.setRunning(data.time);

				
			},
			scope:this
		});
	}

});